/* sudoku-view.c generated by valac 0.56.3, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include "libsudoku.h"
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL_VIEW (sudoku_cell_view_get_type ())
#define SUDOKU_CELL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL_VIEW, SudokuCellView))
#define SUDOKU_CELL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL_VIEW, SudokuCellViewClass))
#define IS_SUDOKU_CELL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL_VIEW))
#define IS_SUDOKU_CELL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL_VIEW))
#define SUDOKU_CELL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL_VIEW, SudokuCellViewClass))

typedef struct _SudokuCellView SudokuCellView;
typedef struct _SudokuCellViewClass SudokuCellViewClass;
typedef struct _SudokuCellViewPrivate SudokuCellViewPrivate;

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
enum  {
	SUDOKU_CELL_VIEW_0_PROPERTY,
	SUDOKU_CELL_VIEW_VALUE_PROPERTY,
	SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY,
	SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_CELL_VIEW_SELECTED_PROPERTY,
	SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY,
	SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY,
	SUDOKU_CELL_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_view_properties[SUDOKU_CELL_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;

struct _SudokuCellView {
	GtkDrawingArea parent_instance;
	SudokuCellViewPrivate * priv;
};

struct _SudokuCellViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _SudokuCellViewPrivate {
	gdouble size_ratio;
	GtkPopover* popover;
	GtkPopover* earmark_popover;
	SudokuGame* game;
	gint row;
	gint col;
	gboolean initialized_earmarks;
	gboolean left_control;
	gboolean right_control;
	gboolean _show_possibilities;
	gboolean _initialize_earmarks;
	gboolean _show_warnings;
	gboolean _selected;
	gboolean _highlighted_background;
	gboolean _highlighted_value;
	NumberPicker* number_picker;
	NumberPicker* earmark_picker;
	GtkEventControllerKey* key_controller;
};

struct _SudokuView {
	GtkAspectFrame parent_instance;
	SudokuViewPrivate * priv;
	SudokuGame* game;
};

struct _SudokuViewClass {
	GtkAspectFrameClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuCellView** cells;
	gint cells_length1;
	gint cells_length2;
	gboolean previous_board_broken_state;
	GtkOverlay* overlay;
	GtkDrawingArea* drawing;
	GtkGrid* grid;
	gint selected_row;
	gint selected_col;
	gboolean _show_warnings;
	gboolean _show_possibilities;
	gboolean _initialize_earmarks;
	gboolean _highlighter;
};

struct _Block9Data {
	int _ref_count_;
	SudokuView* self;
	SudokuGame* game;
};

struct _Block10Data {
	int _ref_count_;
	Block9Data * _data9_;
	gint cell_row;
	gint cell_col;
};

static gint SudokuCellView_private_offset;
static gpointer sudoku_cell_view_parent_class = NULL;
static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCellView, g_object_unref)
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN SudokuCellView* sudoku_cell_view_new (gint row,
                                      gint col,
                                      SudokuGame** game);
VALA_EXTERN SudokuCellView* sudoku_cell_view_construct (GType object_type,
                                            gint row,
                                            gint col,
                                            SudokuGame** game);
static inline void sudoku_cell_view_init_keyboard (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_value (SudokuCellView* self,
                                 gint value);
VALA_EXTERN gboolean sudoku_cell_view_get_is_fixed (SudokuCellView* self);
static gboolean sudoku_cell_view_focus_out_cb (SudokuCellView* self,
                                        GtkWidget* widget,
                                        GdkEventFocus* event);
static gboolean _sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                    GdkEventFocus* event,
                                                                    gpointer self);
VALA_EXTERN void sudoku_cell_view_cell_changed_cb (SudokuCellView* self,
                                       gint row,
                                       gint col,
                                       gint old_val,
                                       gint new_val);
static void _sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                                 gint row,
                                                                 gint col,
                                                                 gint old_val,
                                                                 gint new_val,
                                                                 gpointer self);
static gboolean sudoku_cell_view_real_button_press_event (GtkWidget* base,
                                                   GdkEventButton* event);
VALA_EXTERN void sudoku_cell_view_hide_both_popovers (SudokuCellView* self);
static void sudoku_cell_view_show_earmark_picker (SudokuCellView* self);
static void sudoku_cell_view_show_number_picker (SudokuCellView* self);
static void sudoku_cell_view_create_earmark_picker (SudokuCellView* self);
VALA_EXTERN NumberPicker* number_picker_new (SudokuBoard** board,
                                 gboolean earmark);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuBoard** board,
                                       gboolean earmark);
static void __lambda10_ (SudokuCellView* self,
                  gint number,
                  gboolean state);
VALA_EXTERN gint sudoku_cell_view_get_value (SudokuCellView* self);
static void ___lambda10__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                       gint number,
                                                       gboolean active,
                                                       gpointer self);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static void __lambda7_ (SudokuCellView* self,
                 NumberPicker* o,
                 gint number);
static void ___lambda7__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
static void __lambda8_ (SudokuCellView* self);
static void sudoku_cell_view_destroy_popover (SudokuCellView* self,
                                       GtkPopover** popover,
                                       NumberPicker** picker);
static void ___lambda8__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static gboolean __lambda9_ (SudokuCellView* self);
static gboolean ___lambda9__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                 GdkEventFocus* event,
                                                 gpointer self);
static void __lambda11_ (SudokuCellView* self);
static void ___lambda11__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean __lambda12_ (SudokuCellView* self);
static gboolean ___lambda12__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                  GdkEventFocus* event,
                                                  gpointer self);
static gboolean sudoku_cell_view_warn_incorrect_solution (SudokuCellView* self);
static gint sudoku_cell_view_key_map_keypad (SudokuCellView* self,
                                      const gchar* key_name);
static inline gboolean sudoku_cell_view_on_key_pressed (SudokuCellView* self,
                                          GtkEventControllerKey* _key_controller,
                                          guint keyval,
                                          guint keycode,
                                          GdkModifierType state);
static gboolean _sudoku_cell_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                guint keyval,
                                                                                guint keycode,
                                                                                GdkModifierType state,
                                                                                gpointer self);
static inline void sudoku_cell_view_on_key_release (SudokuCellView* self,
                                      GtkEventControllerKey* _key_controller,
                                      guint keyval,
                                      guint keycode,
                                      GdkModifierType state);
static void _sudoku_cell_view_on_key_release_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                             guint keyval,
                                                                             guint keycode,
                                                                             GdkModifierType state,
                                                                             gpointer self);
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
static gboolean sudoku_cell_view_real_draw (GtkWidget* base,
                                     cairo_t* c);
static void sudoku_cell_view_print_centered (SudokuCellView* self,
                                      cairo_t* c,
                                      const gchar* text,
                                      gdouble width,
                                      gdouble height);
VALA_EXTERN void sudoku_cell_view_clear (SudokuCellView* self);
VALA_EXTERN gboolean sudoku_cell_view_get_show_possibilities (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_show_possibilities (SudokuCellView* self,
                                              gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_initialize_earmarks (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_initialize_earmarks (SudokuCellView* self,
                                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_show_warnings (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_show_warnings (SudokuCellView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_selected (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_selected (SudokuCellView* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_highlighted_background (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_highlighted_background (SudokuCellView* self,
                                                  gboolean value);
VALA_EXTERN gboolean sudoku_cell_view_get_highlighted_value (SudokuCellView* self);
VALA_EXTERN void sudoku_cell_view_set_highlighted_value (SudokuCellView* self,
                                             gboolean value);
static void sudoku_cell_view_finalize (GObject * obj);
static GType sudoku_cell_view_get_type_once (void);
static void _vala_sudoku_cell_view_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_sudoku_cell_view_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
static void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static gboolean sudoku_view_draw_board (SudokuView* self,
                                 cairo_t* c);
static gboolean _sudoku_view_draw_board_gtk_widget_draw (GtkWidget* _sender,
                                                  cairo_t* cr,
                                                  gpointer self);
static void __lambda13_ (SudokuView* self);
static void ___lambda13__sudoku_game_paused_changed (SudokuGame* _sender,
                                              gpointer self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean ________lambda14_ (Block10Data* _data10_);
static void sudoku_view_update_highlights (SudokuView* self);
static gboolean _________lambda14__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                       GdkEventFocus* event,
                                                       gpointer self);
static gboolean ________lambda15_ (Block10Data* _data10_);
static gboolean _________lambda15__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                        GdkEventFocus* event,
                                                        gpointer self);
static void ________lambda16_ (Block10Data* _data10_,
                        GObject* s,
                        GParamSpec* p);
static void _________lambda16__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
VALA_EXTERN void sudoku_view_clear (SudokuView* self);
VALA_EXTERN void sudoku_view_hide_popovers (SudokuView* self);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_view_get_initialize_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_view_set_initialize_earmarks (SudokuView* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

const GdkRGBA selected_bg_color = {0.7, 0.8, 0.9, 1.0};
const GdkRGBA fixed_cell_color = {0.8, 0.8, 0.8, 1.0};
const GdkRGBA highlight_color = {0.93, 0.93, 0.93, 1.0};
const GdkRGBA free_cell_color = {1.0, 1.0, 1.0, 1.0};

static inline gpointer
sudoku_cell_view_get_instance_private (SudokuCellView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCellView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 116 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 408 "sudoku-view.c"
}

static gboolean
_sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                           GdkEventFocus* event,
                                                           gpointer self)
{
	gboolean result;
	result = sudoku_cell_view_focus_out_cb ((SudokuCellView*) self, _sender, event);
#line 132 "../src/sudoku-view.vala"
	return result;
#line 420 "sudoku-view.c"
}

static void
_sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                            gint row,
                                                            gint col,
                                                            gint old_val,
                                                            gint new_val,
                                                            gpointer self)
{
#line 133 "../src/sudoku-view.vala"
	sudoku_cell_view_cell_changed_cb ((SudokuCellView*) self, row, col, old_val, new_val);
#line 433 "sudoku-view.c"
}

SudokuCellView*
sudoku_cell_view_construct (GType object_type,
                            gint row,
                            gint col,
                            SudokuGame** game)
{
	SudokuCellView * self = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 114 "../src/sudoku-view.vala"
	g_return_val_if_fail (*game != NULL, NULL);
#line 114 "../src/sudoku-view.vala"
	self = (SudokuCellView*) g_object_new (object_type, NULL);
#line 116 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (*game);
#line 116 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 116 "../src/sudoku-view.vala"
	self->priv->game = _tmp0_;
#line 117 "../src/sudoku-view.vala"
	self->priv->row = row;
#line 118 "../src/sudoku-view.vala"
	self->priv->col = col;
#line 120 "../src/sudoku-view.vala"
	sudoku_cell_view_init_keyboard (self);
#line 122 "../src/sudoku-view.vala"
	_tmp1_ = (*game)->board;
#line 122 "../src/sudoku-view.vala"
	sudoku_cell_view_set_value (self, sudoku_board_get (_tmp1_, row, col));
#line 126 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 127 "../src/sudoku-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, ((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_KEY_PRESS_MASK);
#line 129 "../src/sudoku-view.vala"
	_tmp3_ = sudoku_cell_view_get_is_fixed (self);
#line 129 "../src/sudoku-view.vala"
	_tmp4_ = _tmp3_;
#line 129 "../src/sudoku-view.vala"
	if (_tmp4_) {
#line 129 "../src/sudoku-view.vala"
		_tmp2_ = (*game)->mode == GAME_MODE_PLAY;
#line 480 "sudoku-view.c"
	} else {
#line 129 "../src/sudoku-view.vala"
		_tmp2_ = FALSE;
#line 484 "sudoku-view.c"
	}
#line 129 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 130 "../src/sudoku-view.vala"
		return self;
#line 490 "sudoku-view.c"
	}
#line 132 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) _sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event, self, 0);
#line 133 "../src/sudoku-view.vala"
	g_signal_connect_object (*game, "cell-changed", (GCallback) _sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed, self, 0);
#line 114 "../src/sudoku-view.vala"
	return self;
#line 498 "sudoku-view.c"
}

SudokuCellView*
sudoku_cell_view_new (gint row,
                      gint col,
                      SudokuGame** game)
{
#line 114 "../src/sudoku-view.vala"
	return sudoku_cell_view_construct (TYPE_SUDOKU_CELL_VIEW, row, col, game);
#line 508 "sudoku-view.c"
}

static gboolean
sudoku_cell_view_real_button_press_event (GtkWidget* base,
                                          GdkEventButton* event)
{
	SudokuCellView * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	SudokuGame* _tmp4_;
	gboolean _tmp11_ = FALSE;
	GtkPopover* _tmp12_;
	gboolean result;
#line 136 "../src/sudoku-view.vala"
	self = (SudokuCellView*) base;
#line 136 "../src/sudoku-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 138 "../src/sudoku-view.vala"
	if (event->button != ((guint) 1)) {
#line 138 "../src/sudoku-view.vala"
		_tmp0_ = event->button != ((guint) 3);
#line 532 "sudoku-view.c"
	} else {
#line 138 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 536 "sudoku-view.c"
	}
#line 138 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 139 "../src/sudoku-view.vala"
		result = FALSE;
#line 139 "../src/sudoku-view.vala"
		return result;
#line 544 "sudoku-view.c"
	}
#line 141 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) self, "is-focus", &_tmp1_, NULL);
#line 141 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 141 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 142 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 554 "sudoku-view.c"
	}
#line 143 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->game;
#line 143 "../src/sudoku-view.vala"
	if (_tmp4_->mode == GAME_MODE_PLAY) {
#line 560 "sudoku-view.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 143 "../src/sudoku-view.vala"
		_tmp6_ = sudoku_cell_view_get_is_fixed (self);
#line 143 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_;
#line 143 "../src/sudoku-view.vala"
		if (_tmp7_) {
#line 143 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 572 "sudoku-view.c"
		} else {
			SudokuGame* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 143 "../src/sudoku-view.vala"
			_tmp8_ = self->priv->game;
#line 143 "../src/sudoku-view.vala"
			_tmp9_ = sudoku_game_get_paused (_tmp8_);
#line 143 "../src/sudoku-view.vala"
			_tmp10_ = _tmp9_;
#line 143 "../src/sudoku-view.vala"
			_tmp5_ = _tmp10_;
#line 585 "sudoku-view.c"
		}
#line 143 "../src/sudoku-view.vala"
		_tmp3_ = _tmp5_;
#line 589 "sudoku-view.c"
	} else {
#line 143 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 593 "sudoku-view.c"
	}
#line 143 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 144 "../src/sudoku-view.vala"
		result = FALSE;
#line 144 "../src/sudoku-view.vala"
		return result;
#line 601 "sudoku-view.c"
	}
#line 146 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->popover;
#line 146 "../src/sudoku-view.vala"
	if (_tmp12_ != NULL) {
#line 146 "../src/sudoku-view.vala"
		_tmp11_ = TRUE;
#line 609 "sudoku-view.c"
	} else {
		GtkPopover* _tmp13_;
#line 146 "../src/sudoku-view.vala"
		_tmp13_ = self->priv->earmark_popover;
#line 146 "../src/sudoku-view.vala"
		_tmp11_ = _tmp13_ != NULL;
#line 616 "sudoku-view.c"
	}
#line 146 "../src/sudoku-view.vala"
	if (_tmp11_) {
#line 148 "../src/sudoku-view.vala"
		sudoku_cell_view_hide_both_popovers (self);
#line 149 "../src/sudoku-view.vala"
		result = FALSE;
#line 149 "../src/sudoku-view.vala"
		return result;
#line 626 "sudoku-view.c"
	}
#line 152 "../src/sudoku-view.vala"
	if (event->button == ((guint) 1)) {
#line 630 "sudoku-view.c"
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
#line 154 "../src/sudoku-view.vala"
		if (!self->priv->_show_possibilities) {
#line 154 "../src/sudoku-view.vala"
			_tmp15_ = (event->state & GDK_CONTROL_MASK) > 0;
#line 637 "sudoku-view.c"
		} else {
#line 154 "../src/sudoku-view.vala"
			_tmp15_ = FALSE;
#line 641 "sudoku-view.c"
		}
#line 154 "../src/sudoku-view.vala"
		if (_tmp15_) {
#line 645 "sudoku-view.c"
			SudokuGame* _tmp16_;
#line 154 "../src/sudoku-view.vala"
			_tmp16_ = self->priv->game;
#line 154 "../src/sudoku-view.vala"
			_tmp14_ = _tmp16_->mode == GAME_MODE_PLAY;
#line 651 "sudoku-view.c"
		} else {
#line 154 "../src/sudoku-view.vala"
			_tmp14_ = FALSE;
#line 655 "sudoku-view.c"
		}
#line 154 "../src/sudoku-view.vala"
		if (_tmp14_) {
#line 155 "../src/sudoku-view.vala"
			sudoku_cell_view_show_earmark_picker (self);
#line 661 "sudoku-view.c"
		} else {
#line 157 "../src/sudoku-view.vala"
			sudoku_cell_view_show_number_picker (self);
#line 665 "sudoku-view.c"
		}
	} else {
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
#line 159 "../src/sudoku-view.vala"
		if (!self->priv->_show_possibilities) {
#line 159 "../src/sudoku-view.vala"
			_tmp18_ = event->button == ((guint) 3);
#line 674 "sudoku-view.c"
		} else {
#line 159 "../src/sudoku-view.vala"
			_tmp18_ = FALSE;
#line 678 "sudoku-view.c"
		}
#line 159 "../src/sudoku-view.vala"
		if (_tmp18_) {
#line 682 "sudoku-view.c"
			SudokuGame* _tmp19_;
#line 159 "../src/sudoku-view.vala"
			_tmp19_ = self->priv->game;
#line 159 "../src/sudoku-view.vala"
			_tmp17_ = _tmp19_->mode == GAME_MODE_PLAY;
#line 688 "sudoku-view.c"
		} else {
#line 159 "../src/sudoku-view.vala"
			_tmp17_ = FALSE;
#line 692 "sudoku-view.c"
		}
#line 159 "../src/sudoku-view.vala"
		if (_tmp17_) {
#line 160 "../src/sudoku-view.vala"
			sudoku_cell_view_show_earmark_picker (self);
#line 698 "sudoku-view.c"
		}
	}
#line 162 "../src/sudoku-view.vala"
	result = FALSE;
#line 162 "../src/sudoku-view.vala"
	return result;
#line 705 "sudoku-view.c"
}

static void
__lambda10_ (SudokuCellView* self,
             gint number,
             gboolean state)
{
	SudokuGame* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 171 "../src/sudoku-view.vala"
	if (state) {
#line 720 "sudoku-view.c"
		SudokuGame* _tmp0_;
		SudokuBoard* _tmp1_;
#line 172 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->game;
#line 172 "../src/sudoku-view.vala"
		_tmp1_ = _tmp0_->board;
#line 172 "../src/sudoku-view.vala"
		sudoku_board_enable_earmark (_tmp1_, self->priv->row, self->priv->col, number);
#line 729 "sudoku-view.c"
	} else {
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
#line 174 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->game;
#line 174 "../src/sudoku-view.vala"
		_tmp3_ = _tmp2_->board;
#line 174 "../src/sudoku-view.vala"
		sudoku_board_disable_earmark (_tmp3_, self->priv->row, self->priv->col, number);
#line 739 "sudoku-view.c"
	}
#line 175 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->game;
#line 175 "../src/sudoku-view.vala"
	_tmp5_ = sudoku_cell_view_get_value (self);
#line 175 "../src/sudoku-view.vala"
	_tmp6_ = _tmp5_;
#line 175 "../src/sudoku-view.vala"
	_tmp7_ = sudoku_cell_view_get_value (self);
#line 175 "../src/sudoku-view.vala"
	_tmp8_ = _tmp7_;
#line 175 "../src/sudoku-view.vala"
	g_signal_emit_by_name (_tmp4_, "cell-changed", self->priv->row, self->priv->col, _tmp6_, _tmp8_);
#line 176 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 755 "sudoku-view.c"
}

static void
___lambda10__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                  gint number,
                                                  gboolean active,
                                                  gpointer self)
{
#line 168 "../src/sudoku-view.vala"
	__lambda10_ ((SudokuCellView*) self, number, active);
#line 766 "sudoku-view.c"
}

static void
sudoku_cell_view_create_earmark_picker (SudokuCellView* self)
{
	SudokuGame* _tmp0_;
	NumberPicker* _tmp1_;
	NumberPicker* _tmp2_;
	NumberPicker* _tmp3_;
#line 165 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 167 "../src/sudoku-view.vala"
	_tmp1_ = number_picker_new (&_tmp0_->board, TRUE);
#line 167 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp1_);
#line 167 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_picker);
#line 167 "../src/sudoku-view.vala"
	self->priv->earmark_picker = _tmp1_;
#line 168 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->earmark_picker;
#line 168 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp2_, "earmark-state-changed", (GCallback) ___lambda10__number_picker_earmark_state_changed, self, 0);
#line 178 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->earmark_picker;
#line 178 "../src/sudoku-view.vala"
	number_picker_set_earmarks (_tmp3_, self->priv->row, self->priv->col);
#line 796 "sudoku-view.c"
}

static void
__lambda7_ (SudokuCellView* self,
            NumberPicker* o,
            gint number)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	GtkPopover* _tmp2_;
#line 187 "../src/sudoku-view.vala"
	g_return_if_fail (o != NULL);
#line 188 "../src/sudoku-view.vala"
	sudoku_cell_view_set_value (self, number);
#line 189 "../src/sudoku-view.vala"
	if (number == 0) {
#line 190 "../src/sudoku-view.vala"
		g_object_notify ((GObject*) self, "value");
#line 815 "sudoku-view.c"
	}
#line 191 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 191 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 191 "../src/sudoku-view.vala"
	sudoku_board_disable_all_earmarks (_tmp1_, self->priv->row, self->priv->col);
#line 193 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->popover;
#line 193 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 827 "sudoku-view.c"
}

static void
___lambda7__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
#line 187 "../src/sudoku-view.vala"
	__lambda7_ ((SudokuCellView*) self, _sender, number);
#line 837 "sudoku-view.c"
}

static void
__lambda8_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 202 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 202 "../src/sudoku-view.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 202 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 202 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 203 "../src/sudoku-view.vala"
		sudoku_cell_view_destroy_popover (self, &self->priv->popover, &self->priv->number_picker);
#line 856 "sudoku-view.c"
	}
}

static void
___lambda8__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 201 "../src/sudoku-view.vala"
	__lambda8_ ((SudokuCellView*) self);
#line 867 "sudoku-view.c"
}

static gboolean
__lambda9_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean result;
#line 206 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 206 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 207 "../src/sudoku-view.vala"
	result = TRUE;
#line 207 "../src/sudoku-view.vala"
	return result;
#line 883 "sudoku-view.c"
}

static gboolean
___lambda9__gtk_widget_focus_out_event (GtkWidget* _sender,
                                        GdkEventFocus* event,
                                        gpointer self)
{
	gboolean result;
	result = __lambda9_ ((SudokuCellView*) self);
#line 205 "../src/sudoku-view.vala"
	return result;
#line 895 "sudoku-view.c"
}

static void
sudoku_cell_view_show_number_picker (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	SudokuGame* _tmp2_;
	NumberPicker* _tmp3_;
	NumberPicker* _tmp4_;
	NumberPicker* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkPopover* _tmp8_;
	GtkPopover* _tmp9_;
	NumberPicker* _tmp10_;
	GtkPopover* _tmp11_;
	GtkPopover* _tmp12_;
	GtkPopover* _tmp13_;
	GtkPopover* _tmp14_;
	GtkPopover* _tmp15_;
#line 181 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->earmark_popover;
#line 183 "../src/sudoku-view.vala"
	if (_tmp0_ != NULL) {
#line 922 "sudoku-view.c"
		GtkPopover* _tmp1_;
#line 184 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->earmark_popover;
#line 184 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 928 "sudoku-view.c"
	}
#line 186 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->game;
#line 186 "../src/sudoku-view.vala"
	_tmp3_ = number_picker_new (&_tmp2_->board, FALSE);
#line 186 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 186 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->number_picker);
#line 186 "../src/sudoku-view.vala"
	self->priv->number_picker = _tmp3_;
#line 187 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->number_picker;
#line 187 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp4_, "number-picked", (GCallback) ___lambda7__number_picker_number_picked, self, 0);
#line 195 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->number_picker;
#line 195 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_cell_view_get_value (self);
#line 195 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 195 "../src/sudoku-view.vala"
	number_picker_set_clear_button_visibility (_tmp5_, _tmp7_ != 0);
#line 197 "../src/sudoku-view.vala"
	_tmp8_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
#line 197 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp8_);
#line 197 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->popover);
#line 197 "../src/sudoku-view.vala"
	self->priv->popover = _tmp8_;
#line 198 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->popover;
#line 198 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->number_picker;
#line 198 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
#line 199 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->popover;
#line 199 "../src/sudoku-view.vala"
	gtk_popover_set_modal (_tmp11_, FALSE);
#line 200 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->popover;
#line 200 "../src/sudoku-view.vala"
	gtk_popover_set_position (_tmp12_, GTK_POS_BOTTOM);
#line 201 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->popover;
#line 201 "../src/sudoku-view.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::visible", (GCallback) ___lambda8__g_object_notify, self, 0);
#line 205 "../src/sudoku-view.vala"
	_tmp14_ = self->priv->popover;
#line 205 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp14_, "focus-out-event", (GCallback) ___lambda9__gtk_widget_focus_out_event, self, 0);
#line 210 "../src/sudoku-view.vala"
	_tmp15_ = self->priv->popover;
#line 210 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp15_);
#line 986 "sudoku-view.c"
}

static void
__lambda11_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 225 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->earmark_popover;
#line 225 "../src/sudoku-view.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 225 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 225 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 226 "../src/sudoku-view.vala"
		sudoku_cell_view_destroy_popover (self, &self->priv->earmark_popover, &self->priv->earmark_picker);
#line 1005 "sudoku-view.c"
	}
}

static void
___lambda11__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 224 "../src/sudoku-view.vala"
	__lambda11_ ((SudokuCellView*) self);
#line 1016 "sudoku-view.c"
}

static gboolean
__lambda12_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean result;
#line 229 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->earmark_popover;
#line 229 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 230 "../src/sudoku-view.vala"
	result = TRUE;
#line 230 "../src/sudoku-view.vala"
	return result;
#line 1032 "sudoku-view.c"
}

static gboolean
___lambda12__gtk_widget_focus_out_event (GtkWidget* _sender,
                                         GdkEventFocus* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda12_ ((SudokuCellView*) self);
#line 228 "../src/sudoku-view.vala"
	return result;
#line 1044 "sudoku-view.c"
}

static void
sudoku_cell_view_show_earmark_picker (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp2_;
	GtkPopover* _tmp3_;
	NumberPicker* _tmp4_;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
	GtkPopover* _tmp7_;
	GtkPopover* _tmp8_;
	GtkPopover* _tmp9_;
#line 213 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 215 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 215 "../src/sudoku-view.vala"
	if (_tmp0_ != NULL) {
#line 1065 "sudoku-view.c"
		GtkPopover* _tmp1_;
#line 216 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->popover;
#line 216 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 1071 "sudoku-view.c"
	}
#line 218 "../src/sudoku-view.vala"
	sudoku_cell_view_create_earmark_picker (self);
#line 220 "../src/sudoku-view.vala"
	_tmp2_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
#line 220 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp2_);
#line 220 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_popover);
#line 220 "../src/sudoku-view.vala"
	self->priv->earmark_popover = _tmp2_;
#line 221 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->earmark_popover;
#line 221 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->earmark_picker;
#line 221 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 222 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->earmark_popover;
#line 222 "../src/sudoku-view.vala"
	gtk_popover_set_modal (_tmp5_, FALSE);
#line 223 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->earmark_popover;
#line 223 "../src/sudoku-view.vala"
	gtk_popover_set_position (_tmp6_, GTK_POS_BOTTOM);
#line 224 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->earmark_popover;
#line 224 "../src/sudoku-view.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::visible", (GCallback) ___lambda11__g_object_notify, self, 0);
#line 228 "../src/sudoku-view.vala"
	_tmp8_ = self->priv->earmark_popover;
#line 228 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp8_, "focus-out-event", (GCallback) ___lambda12__gtk_widget_focus_out_event, self, 0);
#line 233 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->earmark_popover;
#line 233 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp9_);
#line 1109 "sudoku-view.c"
}

static void
sudoku_cell_view_destroy_popover (SudokuCellView* self,
                                  GtkPopover** popover,
                                  NumberPicker** picker)
{
#line 236 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/sudoku-view.vala"
	g_return_if_fail (*popover != NULL);
#line 236 "../src/sudoku-view.vala"
	g_return_if_fail (*picker != NULL);
#line 238 "../src/sudoku-view.vala"
	_g_object_unref0 (*picker);
#line 238 "../src/sudoku-view.vala"
	*picker = NULL;
#line 239 "../src/sudoku-view.vala"
	if ((*popover) != NULL) {
#line 241 "../src/sudoku-view.vala"
		gtk_widget_destroy ((GtkWidget*) (*popover));
#line 242 "../src/sudoku-view.vala"
		_g_object_unref0 (*popover);
#line 242 "../src/sudoku-view.vala"
		*popover = NULL;
#line 245 "../src/sudoku-view.vala"
		if (sudoku_cell_view_warn_incorrect_solution (self)) {
#line 246 "../src/sudoku-view.vala"
			gtk_widget_queue_draw ((GtkWidget*) self);
#line 1139 "sudoku-view.c"
		}
	}
}

void
sudoku_cell_view_hide_both_popovers (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp2_;
#line 250 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 252 "../src/sudoku-view.vala"
	if (_tmp0_ != NULL) {
#line 1155 "sudoku-view.c"
		GtkPopover* _tmp1_;
#line 253 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->popover;
#line 253 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 1161 "sudoku-view.c"
	}
#line 254 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->earmark_popover;
#line 254 "../src/sudoku-view.vala"
	if (_tmp2_ != NULL) {
#line 1167 "sudoku-view.c"
		GtkPopover* _tmp3_;
#line 255 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->earmark_popover;
#line 255 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 1173 "sudoku-view.c"
	}
}

static gboolean
sudoku_cell_view_focus_out_cb (SudokuCellView* self,
                               GtkWidget* widget,
                               GdkEventFocus* event)
{
	gboolean result;
#line 258 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 258 "../src/sudoku-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 258 "../src/sudoku-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 260 "../src/sudoku-view.vala"
	sudoku_cell_view_hide_both_popovers (self);
#line 261 "../src/sudoku-view.vala"
	result = FALSE;
#line 261 "../src/sudoku-view.vala"
	return result;
#line 1195 "sudoku-view.c"
}

static gint
sudoku_cell_view_key_map_keypad (SudokuCellView* self,
                                 const gchar* key_name)
{
	gboolean _tmp0_ = FALSE;
	gint result;
#line 265 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 265 "../src/sudoku-view.vala"
	g_return_val_if_fail (key_name != NULL, 0);
#line 268 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_0") == 0) {
#line 268 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 1212 "sudoku-view.c"
	} else {
#line 268 "../src/sudoku-view.vala"
		_tmp0_ = g_strcmp0 (key_name, "0") == 0;
#line 1216 "sudoku-view.c"
	}
#line 268 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 269 "../src/sudoku-view.vala"
		result = 0;
#line 269 "../src/sudoku-view.vala"
		return result;
#line 1224 "sudoku-view.c"
	}
#line 270 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_1") == 0) {
#line 271 "../src/sudoku-view.vala"
		result = 1;
#line 271 "../src/sudoku-view.vala"
		return result;
#line 1232 "sudoku-view.c"
	}
#line 272 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_2") == 0) {
#line 273 "../src/sudoku-view.vala"
		result = 2;
#line 273 "../src/sudoku-view.vala"
		return result;
#line 1240 "sudoku-view.c"
	}
#line 274 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_3") == 0) {
#line 275 "../src/sudoku-view.vala"
		result = 3;
#line 275 "../src/sudoku-view.vala"
		return result;
#line 1248 "sudoku-view.c"
	}
#line 276 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_4") == 0) {
#line 277 "../src/sudoku-view.vala"
		result = 4;
#line 277 "../src/sudoku-view.vala"
		return result;
#line 1256 "sudoku-view.c"
	}
#line 278 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_5") == 0) {
#line 279 "../src/sudoku-view.vala"
		result = 5;
#line 279 "../src/sudoku-view.vala"
		return result;
#line 1264 "sudoku-view.c"
	}
#line 280 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_6") == 0) {
#line 281 "../src/sudoku-view.vala"
		result = 6;
#line 281 "../src/sudoku-view.vala"
		return result;
#line 1272 "sudoku-view.c"
	}
#line 282 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_7") == 0) {
#line 283 "../src/sudoku-view.vala"
		result = 7;
#line 283 "../src/sudoku-view.vala"
		return result;
#line 1280 "sudoku-view.c"
	}
#line 284 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_8") == 0) {
#line 285 "../src/sudoku-view.vala"
		result = 8;
#line 285 "../src/sudoku-view.vala"
		return result;
#line 1288 "sudoku-view.c"
	}
#line 286 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_9") == 0) {
#line 287 "../src/sudoku-view.vala"
		result = 9;
#line 287 "../src/sudoku-view.vala"
		return result;
#line 1296 "sudoku-view.c"
	}
#line 288 "../src/sudoku-view.vala"
	result = -1;
#line 288 "../src/sudoku-view.vala"
	return result;
#line 1302 "sudoku-view.c"
}

static gboolean
_sudoku_cell_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                       guint keyval,
                                                                       guint keycode,
                                                                       GdkModifierType state,
                                                                       gpointer self)
{
	gboolean result;
	result = sudoku_cell_view_on_key_pressed ((SudokuCellView*) self, _sender, keyval, keycode, state);
#line 294 "../src/sudoku-view.vala"
	return result;
#line 1316 "sudoku-view.c"
}

static void
_sudoku_cell_view_on_key_release_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                        guint keyval,
                                                                        guint keycode,
                                                                        GdkModifierType state,
                                                                        gpointer self)
{
#line 295 "../src/sudoku-view.vala"
	sudoku_cell_view_on_key_release ((SudokuCellView*) self, _sender, keyval, keycode, state);
#line 1328 "sudoku-view.c"
}

static inline void
sudoku_cell_view_init_keyboard (SudokuCellView* self)
{
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
	GtkEventControllerKey* _tmp2_;
#line 291 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/sudoku-view.vala"
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 293 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 293 "../src/sudoku-view.vala"
	self->priv->key_controller = _tmp0_;
#line 294 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->key_controller;
#line 294 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) _sudoku_cell_view_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 295 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->key_controller;
#line 295 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp2_, "key-released", (GCallback) _sudoku_cell_view_on_key_release_gtk_event_controller_key_key_released, self, 0);
#line 1353 "sudoku-view.c"
}

static inline gboolean
sudoku_cell_view_on_key_pressed (SudokuCellView* self,
                                 GtkEventControllerKey* _key_controller,
                                 guint keyval,
                                 guint keycode,
                                 GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	gchar* k_name = NULL;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gint k_no = 0;
	const gchar* _tmp10_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	const gchar* _tmp33_;
	const gchar* _tmp38_;
	gboolean result;
#line 298 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 298 "../src/sudoku-view.vala"
	g_return_val_if_fail (_key_controller != NULL, FALSE);
#line 300 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 301 "../src/sudoku-view.vala"
		self->priv->left_control = TRUE;
#line 1386 "sudoku-view.c"
	}
#line 302 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Control_R) {
#line 303 "../src/sudoku-view.vala"
		self->priv->right_control = TRUE;
#line 1392 "sudoku-view.c"
	}
#line 305 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->game;
#line 305 "../src/sudoku-view.vala"
	if (_tmp1_->mode == GAME_MODE_PLAY) {
#line 1398 "sudoku-view.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 305 "../src/sudoku-view.vala"
		_tmp3_ = sudoku_cell_view_get_is_fixed (self);
#line 305 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_;
#line 305 "../src/sudoku-view.vala"
		if (_tmp4_) {
#line 305 "../src/sudoku-view.vala"
			_tmp2_ = TRUE;
#line 1410 "sudoku-view.c"
		} else {
			SudokuGame* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 305 "../src/sudoku-view.vala"
			_tmp5_ = self->priv->game;
#line 305 "../src/sudoku-view.vala"
			_tmp6_ = sudoku_game_get_paused (_tmp5_);
#line 305 "../src/sudoku-view.vala"
			_tmp7_ = _tmp6_;
#line 305 "../src/sudoku-view.vala"
			_tmp2_ = _tmp7_;
#line 1423 "sudoku-view.c"
		}
#line 305 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_;
#line 1427 "sudoku-view.c"
	} else {
#line 305 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 1431 "sudoku-view.c"
	}
#line 305 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 306 "../src/sudoku-view.vala"
		result = FALSE;
#line 306 "../src/sudoku-view.vala"
		return result;
#line 1439 "sudoku-view.c"
	}
#line 307 "../src/sudoku-view.vala"
	_tmp8_ = gdk_keyval_name (keyval);
#line 307 "../src/sudoku-view.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 307 "../src/sudoku-view.vala"
	k_name = _tmp9_;
#line 308 "../src/sudoku-view.vala"
	_tmp10_ = k_name;
#line 308 "../src/sudoku-view.vala"
	k_no = atoi (_tmp10_);
#line 310 "../src/sudoku-view.vala"
	if (k_no == 0) {
#line 1453 "sudoku-view.c"
		const gchar* _tmp11_;
#line 311 "../src/sudoku-view.vala"
		_tmp11_ = k_name;
#line 311 "../src/sudoku-view.vala"
		k_no = sudoku_cell_view_key_map_keypad (self, _tmp11_);
#line 1459 "sudoku-view.c"
	}
#line 312 "../src/sudoku-view.vala"
	if (k_no >= 1) {
#line 312 "../src/sudoku-view.vala"
		_tmp12_ = k_no <= 9;
#line 1465 "sudoku-view.c"
	} else {
#line 312 "../src/sudoku-view.vala"
		_tmp12_ = FALSE;
#line 1469 "sudoku-view.c"
	}
#line 312 "../src/sudoku-view.vala"
	if (_tmp12_) {
#line 1473 "sudoku-view.c"
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		GtkPopover* _tmp15_;
		gboolean want_earmark = FALSE;
		gboolean _tmp17_ = FALSE;
#line 314 "../src/sudoku-view.vala"
		_tmp15_ = self->priv->earmark_popover;
#line 314 "../src/sudoku-view.vala"
		if (_tmp15_ != NULL) {
#line 1483 "sudoku-view.c"
			GtkPopover* _tmp16_;
#line 314 "../src/sudoku-view.vala"
			_tmp16_ = self->priv->earmark_popover;
#line 314 "../src/sudoku-view.vala"
			_tmp14_ = gtk_widget_is_visible ((GtkWidget*) _tmp16_);
#line 1489 "sudoku-view.c"
		} else {
#line 314 "../src/sudoku-view.vala"
			_tmp14_ = FALSE;
#line 1493 "sudoku-view.c"
		}
#line 314 "../src/sudoku-view.vala"
		if (_tmp14_) {
#line 314 "../src/sudoku-view.vala"
			_tmp13_ = TRUE;
#line 1499 "sudoku-view.c"
		} else {
#line 315 "../src/sudoku-view.vala"
			_tmp13_ = (state & GDK_CONTROL_MASK) > 0;
#line 1503 "sudoku-view.c"
		}
#line 314 "../src/sudoku-view.vala"
		want_earmark = _tmp13_;
#line 316 "../src/sudoku-view.vala"
		if (want_earmark) {
#line 1509 "sudoku-view.c"
			SudokuGame* _tmp18_;
#line 316 "../src/sudoku-view.vala"
			_tmp18_ = self->priv->game;
#line 316 "../src/sudoku-view.vala"
			_tmp17_ = _tmp18_->mode == GAME_MODE_PLAY;
#line 1515 "sudoku-view.c"
		} else {
#line 316 "../src/sudoku-view.vala"
			_tmp17_ = FALSE;
#line 1519 "sudoku-view.c"
		}
#line 316 "../src/sudoku-view.vala"
		if (_tmp17_) {
#line 1523 "sudoku-view.c"
			gboolean new_state = FALSE;
			SudokuGame* _tmp19_;
			SudokuBoard* _tmp20_;
			NumberPicker* _tmp23_;
#line 318 "../src/sudoku-view.vala"
			_tmp19_ = self->priv->game;
#line 318 "../src/sudoku-view.vala"
			_tmp20_ = _tmp19_->board;
#line 318 "../src/sudoku-view.vala"
			new_state = !sudoku_board_is_earmark_enabled (_tmp20_, self->priv->row, self->priv->col, k_no);
#line 319 "../src/sudoku-view.vala"
			if (new_state) {
#line 1536 "sudoku-view.c"
				SudokuGame* _tmp21_;
#line 320 "../src/sudoku-view.vala"
				_tmp21_ = self->priv->game;
#line 320 "../src/sudoku-view.vala"
				sudoku_game_enable_earmark (_tmp21_, self->priv->row, self->priv->col, k_no);
#line 1542 "sudoku-view.c"
			} else {
				SudokuGame* _tmp22_;
#line 322 "../src/sudoku-view.vala"
				_tmp22_ = self->priv->game;
#line 322 "../src/sudoku-view.vala"
				sudoku_game_disable_earmark (_tmp22_, self->priv->row, self->priv->col, k_no);
#line 1549 "sudoku-view.c"
			}
#line 324 "../src/sudoku-view.vala"
			_tmp23_ = self->priv->earmark_picker;
#line 324 "../src/sudoku-view.vala"
			if (_tmp23_ != NULL) {
#line 1555 "sudoku-view.c"
				NumberPicker* _tmp24_;
#line 325 "../src/sudoku-view.vala"
				_tmp24_ = self->priv->earmark_picker;
#line 325 "../src/sudoku-view.vala"
				number_picker_set_earmark (_tmp24_, self->priv->row, self->priv->col, k_no - 1, new_state);
#line 1561 "sudoku-view.c"
			}
#line 327 "../src/sudoku-view.vala"
			gtk_widget_queue_draw ((GtkWidget*) self);
#line 1565 "sudoku-view.c"
		} else {
			SudokuGame* _tmp25_;
			SudokuBoard* _tmp26_;
#line 331 "../src/sudoku-view.vala"
			sudoku_cell_view_set_value (self, k_no);
#line 332 "../src/sudoku-view.vala"
			_tmp25_ = self->priv->game;
#line 332 "../src/sudoku-view.vala"
			_tmp26_ = _tmp25_->board;
#line 332 "../src/sudoku-view.vala"
			sudoku_board_disable_all_earmarks (_tmp26_, self->priv->row, self->priv->col);
#line 333 "../src/sudoku-view.vala"
			sudoku_cell_view_hide_both_popovers (self);
#line 1579 "sudoku-view.c"
		}
#line 335 "../src/sudoku-view.vala"
		result = TRUE;
#line 335 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 335 "../src/sudoku-view.vala"
		return result;
#line 1587 "sudoku-view.c"
	}
#line 337 "../src/sudoku-view.vala"
	if (k_no == 0) {
#line 337 "../src/sudoku-view.vala"
		_tmp28_ = TRUE;
#line 1593 "sudoku-view.c"
	} else {
		const gchar* _tmp29_;
#line 337 "../src/sudoku-view.vala"
		_tmp29_ = k_name;
#line 337 "../src/sudoku-view.vala"
		_tmp28_ = g_strcmp0 (_tmp29_, "BackSpace") == 0;
#line 1600 "sudoku-view.c"
	}
#line 337 "../src/sudoku-view.vala"
	if (_tmp28_) {
#line 337 "../src/sudoku-view.vala"
		_tmp27_ = TRUE;
#line 1606 "sudoku-view.c"
	} else {
		const gchar* _tmp30_;
#line 337 "../src/sudoku-view.vala"
		_tmp30_ = k_name;
#line 337 "../src/sudoku-view.vala"
		_tmp27_ = g_strcmp0 (_tmp30_, "Delete") == 0;
#line 1613 "sudoku-view.c"
	}
#line 337 "../src/sudoku-view.vala"
	if (_tmp27_) {
#line 339 "../src/sudoku-view.vala"
		sudoku_cell_view_set_value (self, 0);
#line 340 "../src/sudoku-view.vala"
		g_object_notify ((GObject*) self, "value");
#line 341 "../src/sudoku-view.vala"
		result = TRUE;
#line 341 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 341 "../src/sudoku-view.vala"
		return result;
#line 1627 "sudoku-view.c"
	}
#line 344 "../src/sudoku-view.vala"
	_tmp33_ = k_name;
#line 344 "../src/sudoku-view.vala"
	if (g_strcmp0 (_tmp33_, "space") == 0) {
#line 344 "../src/sudoku-view.vala"
		_tmp32_ = TRUE;
#line 1635 "sudoku-view.c"
	} else {
		const gchar* _tmp34_;
#line 344 "../src/sudoku-view.vala"
		_tmp34_ = k_name;
#line 344 "../src/sudoku-view.vala"
		_tmp32_ = g_strcmp0 (_tmp34_, "Return") == 0;
#line 1642 "sudoku-view.c"
	}
#line 344 "../src/sudoku-view.vala"
	if (_tmp32_) {
#line 344 "../src/sudoku-view.vala"
		_tmp31_ = TRUE;
#line 1648 "sudoku-view.c"
	} else {
		const gchar* _tmp35_;
#line 344 "../src/sudoku-view.vala"
		_tmp35_ = k_name;
#line 344 "../src/sudoku-view.vala"
		_tmp31_ = g_strcmp0 (_tmp35_, "KP_Enter") == 0;
#line 1655 "sudoku-view.c"
	}
#line 344 "../src/sudoku-view.vala"
	if (_tmp31_) {
#line 1659 "sudoku-view.c"
		GtkPopover* _tmp36_;
#line 346 "../src/sudoku-view.vala"
		_tmp36_ = self->priv->popover;
#line 346 "../src/sudoku-view.vala"
		if (_tmp36_ != NULL) {
#line 1665 "sudoku-view.c"
			GtkPopover* _tmp37_;
#line 348 "../src/sudoku-view.vala"
			_tmp37_ = self->priv->popover;
#line 348 "../src/sudoku-view.vala"
			gtk_widget_hide ((GtkWidget*) _tmp37_);
#line 349 "../src/sudoku-view.vala"
			result = FALSE;
#line 349 "../src/sudoku-view.vala"
			_g_free0 (k_name);
#line 349 "../src/sudoku-view.vala"
			return result;
#line 1677 "sudoku-view.c"
		}
#line 351 "../src/sudoku-view.vala"
		sudoku_cell_view_show_number_picker (self);
#line 352 "../src/sudoku-view.vala"
		result = TRUE;
#line 352 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 352 "../src/sudoku-view.vala"
		return result;
#line 1687 "sudoku-view.c"
	}
#line 355 "../src/sudoku-view.vala"
	_tmp38_ = k_name;
#line 355 "../src/sudoku-view.vala"
	if (g_strcmp0 (_tmp38_, "Escape") == 0) {
#line 357 "../src/sudoku-view.vala"
		sudoku_cell_view_hide_both_popovers (self);
#line 358 "../src/sudoku-view.vala"
		result = TRUE;
#line 358 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 358 "../src/sudoku-view.vala"
		return result;
#line 1701 "sudoku-view.c"
	}
#line 361 "../src/sudoku-view.vala"
	result = FALSE;
#line 361 "../src/sudoku-view.vala"
	_g_free0 (k_name);
#line 361 "../src/sudoku-view.vala"
	return result;
#line 1709 "sudoku-view.c"
}

static inline void
sudoku_cell_view_on_key_release (SudokuCellView* self,
                                 GtkEventControllerKey* _key_controller,
                                 guint keyval,
                                 guint keycode,
                                 GdkModifierType state)
{
	gboolean control_released = FALSE;
	gboolean _tmp0_ = FALSE;
#line 364 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 364 "../src/sudoku-view.vala"
	g_return_if_fail (_key_controller != NULL);
#line 366 "../src/sudoku-view.vala"
	control_released = FALSE;
#line 367 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 369 "../src/sudoku-view.vala"
		self->priv->left_control = FALSE;
#line 370 "../src/sudoku-view.vala"
		control_released = TRUE;
#line 1733 "sudoku-view.c"
	}
#line 372 "../src/sudoku-view.vala"
	if (keyval == GDK_KEY_Control_R) {
#line 374 "../src/sudoku-view.vala"
		self->priv->right_control = FALSE;
#line 375 "../src/sudoku-view.vala"
		control_released = TRUE;
#line 1741 "sudoku-view.c"
	}
#line 379 "../src/sudoku-view.vala"
	if (control_released) {
#line 379 "../src/sudoku-view.vala"
		_tmp0_ = sudoku_cell_view_warn_incorrect_solution (self);
#line 1747 "sudoku-view.c"
	} else {
#line 379 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 1751 "sudoku-view.c"
	}
#line 379 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 380 "../src/sudoku-view.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 1757 "sudoku-view.c"
	}
}

static gboolean
sudoku_cell_view_real_draw (GtkWidget* base,
                            cairo_t* c)
{
	SudokuCellView * self;
	GdkRGBA background_color = {0};
	gboolean _tmp0_ = FALSE;
	GdkRGBA _tmp21_;
	GdkRGBA _tmp22_;
	GdkRGBA _tmp23_;
	GdkRGBA _tmp24_;
	gboolean _tmp25_ = FALSE;
	SudokuGame* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_;
	gboolean _tmp41_;
	gboolean* marks = NULL;
	gint marks_length1;
	gint _marks_size_;
	gboolean* _tmp71_;
	gint _tmp71__length1;
	gboolean _tmp104_ = FALSE;
	gboolean result;
#line 383 "../src/sudoku-view.vala"
	self = (SudokuCellView*) base;
#line 383 "../src/sudoku-view.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 386 "../src/sudoku-view.vala"
	if (self->priv->_selected) {
#line 1794 "sudoku-view.c"
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 386 "../src/sudoku-view.vala"
		g_object_get ((GtkWidget*) self, "is-focus", &_tmp1_, NULL);
#line 386 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_;
#line 386 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_;
#line 1803 "sudoku-view.c"
	} else {
#line 386 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 1807 "sudoku-view.c"
	}
#line 386 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 387 "../src/sudoku-view.vala"
		background_color = selected_bg_color;
#line 1813 "sudoku-view.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 388 "../src/sudoku-view.vala"
		_tmp3_ = sudoku_cell_view_get_is_fixed (self);
#line 388 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_;
#line 388 "../src/sudoku-view.vala"
		if (_tmp4_) {
#line 389 "../src/sudoku-view.vala"
			background_color = fixed_cell_color;
#line 1825 "sudoku-view.c"
		} else {
#line 390 "../src/sudoku-view.vala"
			if (self->priv->_highlighted_background) {
#line 391 "../src/sudoku-view.vala"
				background_color = highlight_color;
#line 1831 "sudoku-view.c"
			} else {
#line 393 "../src/sudoku-view.vala"
				background_color = free_cell_color;
#line 1835 "sudoku-view.c"
			}
		}
	}
#line 397 "../src/sudoku-view.vala"
	if (sudoku_cell_view_warn_incorrect_solution (self)) {
#line 1841 "sudoku-view.c"
		gboolean cell_error = FALSE;
		gint solution = 0;
		SudokuGame* _tmp5_;
		SudokuBoard* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 399 "../src/sudoku-view.vala"
		cell_error = FALSE;
#line 400 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->game;
#line 400 "../src/sudoku-view.vala"
		_tmp6_ = _tmp5_->board;
#line 400 "../src/sudoku-view.vala"
		solution = sudoku_board_get_solution (_tmp6_, self->priv->row, self->priv->col);
#line 401 "../src/sudoku-view.vala"
		_tmp7_ = sudoku_cell_view_get_value (self);
#line 401 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_;
#line 401 "../src/sudoku-view.vala"
		if (_tmp8_ != 0) {
#line 1862 "sudoku-view.c"
			gint _tmp9_;
			gint _tmp10_;
#line 404 "../src/sudoku-view.vala"
			_tmp9_ = sudoku_cell_view_get_value (self);
#line 404 "../src/sudoku-view.vala"
			_tmp10_ = _tmp9_;
#line 404 "../src/sudoku-view.vala"
			cell_error = _tmp10_ != solution;
#line 1871 "sudoku-view.c"
		} else {
			gboolean* marks = NULL;
			SudokuGame* _tmp11_;
			SudokuBoard* _tmp12_;
			gint _tmp13_ = 0;
			gboolean* _tmp14_;
			gint marks_length1;
			gint _marks_size_;
			gboolean earmarked = FALSE;
			gboolean solution_found = FALSE;
			gboolean _tmp20_ = FALSE;
#line 409 "../src/sudoku-view.vala"
			_tmp11_ = self->priv->game;
#line 409 "../src/sudoku-view.vala"
			_tmp12_ = _tmp11_->board;
#line 409 "../src/sudoku-view.vala"
			_tmp14_ = sudoku_board_get_earmarks (_tmp12_, self->priv->row, self->priv->col, &_tmp13_);
#line 409 "../src/sudoku-view.vala"
			marks = _tmp14_;
#line 409 "../src/sudoku-view.vala"
			marks_length1 = _tmp13_;
#line 409 "../src/sudoku-view.vala"
			_marks_size_ = marks_length1;
#line 410 "../src/sudoku-view.vala"
			earmarked = FALSE;
#line 411 "../src/sudoku-view.vala"
			solution_found = FALSE;
#line 1899 "sudoku-view.c"
			{
				gint num = 0;
#line 412 "../src/sudoku-view.vala"
				num = 1;
#line 1904 "sudoku-view.c"
				{
					gboolean _tmp15_ = FALSE;
#line 412 "../src/sudoku-view.vala"
					_tmp15_ = TRUE;
#line 412 "../src/sudoku-view.vala"
					while (TRUE) {
#line 1911 "sudoku-view.c"
						gboolean* _tmp17_;
						gint _tmp17__length1;
						gboolean* _tmp18_;
						gint _tmp18__length1;
						gboolean _tmp19_;
#line 412 "../src/sudoku-view.vala"
						if (!_tmp15_) {
#line 1919 "sudoku-view.c"
							gint _tmp16_;
#line 412 "../src/sudoku-view.vala"
							_tmp16_ = num;
#line 412 "../src/sudoku-view.vala"
							num = _tmp16_ + 1;
#line 1925 "sudoku-view.c"
						}
#line 412 "../src/sudoku-view.vala"
						_tmp15_ = FALSE;
#line 412 "../src/sudoku-view.vala"
						_tmp17_ = marks;
#line 412 "../src/sudoku-view.vala"
						_tmp17__length1 = marks_length1;
#line 412 "../src/sudoku-view.vala"
						if (!(num <= _tmp17__length1)) {
#line 412 "../src/sudoku-view.vala"
							break;
#line 1937 "sudoku-view.c"
						}
#line 414 "../src/sudoku-view.vala"
						_tmp18_ = marks;
#line 414 "../src/sudoku-view.vala"
						_tmp18__length1 = marks_length1;
#line 414 "../src/sudoku-view.vala"
						_tmp19_ = _tmp18_[num - 1];
#line 414 "../src/sudoku-view.vala"
						if (_tmp19_) {
#line 416 "../src/sudoku-view.vala"
							earmarked = TRUE;
#line 417 "../src/sudoku-view.vala"
							if (num == solution) {
#line 418 "../src/sudoku-view.vala"
								solution_found = TRUE;
#line 1953 "sudoku-view.c"
							}
						}
					}
				}
			}
#line 421 "../src/sudoku-view.vala"
			if (earmarked) {
#line 421 "../src/sudoku-view.vala"
				_tmp20_ = !solution_found;
#line 1963 "sudoku-view.c"
			} else {
#line 421 "../src/sudoku-view.vala"
				_tmp20_ = FALSE;
#line 1967 "sudoku-view.c"
			}
#line 421 "../src/sudoku-view.vala"
			if (_tmp20_) {
#line 422 "../src/sudoku-view.vala"
				cell_error = TRUE;
#line 1973 "sudoku-view.c"
			}
#line 401 "../src/sudoku-view.vala"
			marks = (g_free (marks), NULL);
#line 1977 "sudoku-view.c"
		}
#line 426 "../src/sudoku-view.vala"
		if (cell_error) {
#line 428 "../src/sudoku-view.vala"
			background_color.green = background_color.green * 0.6;
#line 429 "../src/sudoku-view.vala"
			background_color.blue = background_color.blue * 0.6;
#line 1985 "sudoku-view.c"
		}
	}
#line 433 "../src/sudoku-view.vala"
	_tmp21_ = background_color;
#line 433 "../src/sudoku-view.vala"
	_tmp22_ = background_color;
#line 433 "../src/sudoku-view.vala"
	_tmp23_ = background_color;
#line 433 "../src/sudoku-view.vala"
	_tmp24_ = background_color;
#line 433 "../src/sudoku-view.vala"
	cairo_set_source_rgba (c, _tmp21_.red, _tmp22_.green, _tmp23_.blue, _tmp24_.alpha);
#line 434 "../src/sudoku-view.vala"
	cairo_rectangle (c, (gdouble) 0, (gdouble) 0, (gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self), (gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self));
#line 435 "../src/sudoku-view.vala"
	cairo_fill (c);
#line 437 "../src/sudoku-view.vala"
	if (self->priv->_show_warnings) {
#line 2004 "sudoku-view.c"
		SudokuGame* _tmp26_;
		SudokuBoard* _tmp27_;
		GeeSet* _tmp28_;
		Coord _tmp29_ = {0};
#line 437 "../src/sudoku-view.vala"
		_tmp26_ = self->priv->game;
#line 437 "../src/sudoku-view.vala"
		_tmp27_ = _tmp26_->board;
#line 437 "../src/sudoku-view.vala"
		_tmp28_ = _tmp27_->broken_coords;
#line 437 "../src/sudoku-view.vala"
		coord_init (&_tmp29_, self->priv->row, self->priv->col);
#line 437 "../src/sudoku-view.vala"
		_tmp25_ = gee_collection_contains ((GeeCollection*) _tmp28_, &_tmp29_);
#line 2019 "sudoku-view.c"
	} else {
#line 437 "../src/sudoku-view.vala"
		_tmp25_ = FALSE;
#line 2023 "sudoku-view.c"
	}
#line 437 "../src/sudoku-view.vala"
	if (_tmp25_) {
#line 438 "../src/sudoku-view.vala"
		cairo_set_source_rgb (c, 1.0, 0.0, 0.0);
#line 2029 "sudoku-view.c"
	} else {
#line 439 "../src/sudoku-view.vala"
		if (self->priv->_highlighted_value) {
#line 440 "../src/sudoku-view.vala"
			cairo_set_source_rgb (c, 0.2, 0.4, 0.9);
#line 2035 "sudoku-view.c"
		} else {
#line 441 "../src/sudoku-view.vala"
			if (self->priv->_selected) {
#line 442 "../src/sudoku-view.vala"
				cairo_set_source_rgb (c, 0.2, 0.2, 0.2);
#line 2041 "sudoku-view.c"
			} else {
#line 444 "../src/sudoku-view.vala"
				cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
#line 2045 "sudoku-view.c"
			}
		}
	}
#line 446 "../src/sudoku-view.vala"
	_tmp30_ = self->priv->game;
#line 446 "../src/sudoku-view.vala"
	_tmp31_ = sudoku_game_get_paused (_tmp30_);
#line 446 "../src/sudoku-view.vala"
	_tmp32_ = _tmp31_;
#line 446 "../src/sudoku-view.vala"
	if (_tmp32_) {
#line 447 "../src/sudoku-view.vala"
		result = FALSE;
#line 447 "../src/sudoku-view.vala"
		return result;
#line 2061 "sudoku-view.c"
	}
#line 449 "../src/sudoku-view.vala"
	_tmp33_ = sudoku_cell_view_get_value (self);
#line 449 "../src/sudoku-view.vala"
	_tmp34_ = _tmp33_;
#line 449 "../src/sudoku-view.vala"
	if (_tmp34_ != 0) {
#line 2069 "sudoku-view.c"
		gdouble height = 0.0;
		gdouble width = 0.0;
		gchar* text = NULL;
		gint _tmp35_;
		gint _tmp36_;
		gchar* _tmp37_;
		const gchar* _tmp38_;
#line 451 "../src/sudoku-view.vala"
		height = (gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 452 "../src/sudoku-view.vala"
		width = (gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 453 "../src/sudoku-view.vala"
		_tmp35_ = sudoku_cell_view_get_value (self);
#line 453 "../src/sudoku-view.vala"
		_tmp36_ = _tmp35_;
#line 453 "../src/sudoku-view.vala"
		_tmp37_ = g_strdup_printf ("%d", _tmp36_);
#line 453 "../src/sudoku-view.vala"
		text = _tmp37_;
#line 455 "../src/sudoku-view.vala"
		cairo_set_font_size (c, height / self->priv->size_ratio);
#line 456 "../src/sudoku-view.vala"
		_tmp38_ = text;
#line 456 "../src/sudoku-view.vala"
		sudoku_cell_view_print_centered (self, c, _tmp38_, width, height);
#line 457 "../src/sudoku-view.vala"
		result = FALSE;
#line 457 "../src/sudoku-view.vala"
		_g_free0 (text);
#line 457 "../src/sudoku-view.vala"
		return result;
#line 2101 "sudoku-view.c"
	}
#line 460 "../src/sudoku-view.vala"
	_tmp40_ = sudoku_cell_view_get_is_fixed (self);
#line 460 "../src/sudoku-view.vala"
	_tmp41_ = _tmp40_;
#line 460 "../src/sudoku-view.vala"
	if (_tmp41_) {
#line 2109 "sudoku-view.c"
		SudokuGame* _tmp42_;
#line 460 "../src/sudoku-view.vala"
		_tmp42_ = self->priv->game;
#line 460 "../src/sudoku-view.vala"
		_tmp39_ = _tmp42_->mode == GAME_MODE_PLAY;
#line 2115 "sudoku-view.c"
	} else {
#line 460 "../src/sudoku-view.vala"
		_tmp39_ = FALSE;
#line 2119 "sudoku-view.c"
	}
#line 460 "../src/sudoku-view.vala"
	if (_tmp39_) {
#line 461 "../src/sudoku-view.vala"
		result = FALSE;
#line 461 "../src/sudoku-view.vala"
		return result;
#line 2127 "sudoku-view.c"
	}
#line 463 "../src/sudoku-view.vala"
	marks = NULL;
#line 463 "../src/sudoku-view.vala"
	marks_length1 = 0;
#line 463 "../src/sudoku-view.vala"
	_marks_size_ = marks_length1;
#line 464 "../src/sudoku-view.vala"
	if (!self->priv->_show_possibilities) {
#line 2137 "sudoku-view.c"
		SudokuGame* _tmp61_;
		SudokuBoard* _tmp62_;
		gint _tmp63_ = 0;
		gboolean* _tmp64_;
#line 467 "../src/sudoku-view.vala"
		if (!self->priv->initialized_earmarks) {
#line 2144 "sudoku-view.c"
			gboolean _tmp43_ = FALSE;
			gboolean _tmp44_ = FALSE;
#line 471 "../src/sudoku-view.vala"
			if (self->priv->_initialize_earmarks) {
#line 2149 "sudoku-view.c"
				SudokuGame* _tmp45_;
#line 471 "../src/sudoku-view.vala"
				_tmp45_ = self->priv->game;
#line 471 "../src/sudoku-view.vala"
				_tmp44_ = _tmp45_->mode == GAME_MODE_PLAY;
#line 2155 "sudoku-view.c"
			} else {
#line 471 "../src/sudoku-view.vala"
				_tmp44_ = FALSE;
#line 2159 "sudoku-view.c"
			}
#line 471 "../src/sudoku-view.vala"
			if (_tmp44_) {
#line 2163 "sudoku-view.c"
				SudokuGame* _tmp46_;
				SudokuBoard* _tmp47_;
				gdouble _tmp48_;
				gdouble _tmp49_;
#line 472 "../src/sudoku-view.vala"
				_tmp46_ = self->priv->game;
#line 472 "../src/sudoku-view.vala"
				_tmp47_ = _tmp46_->board;
#line 472 "../src/sudoku-view.vala"
				_tmp48_ = sudoku_board_get_previous_played_time (_tmp47_);
#line 472 "../src/sudoku-view.vala"
				_tmp49_ = _tmp48_;
#line 472 "../src/sudoku-view.vala"
				_tmp43_ = _tmp49_ == 0.0;
#line 2178 "sudoku-view.c"
			} else {
#line 471 "../src/sudoku-view.vala"
				_tmp43_ = FALSE;
#line 2182 "sudoku-view.c"
			}
#line 471 "../src/sudoku-view.vala"
			if (_tmp43_) {
#line 2186 "sudoku-view.c"
				SudokuGame* _tmp50_;
				SudokuBoard* _tmp51_;
				gint _tmp52_ = 0;
				gboolean* _tmp53_;
#line 474 "../src/sudoku-view.vala"
				_tmp50_ = self->priv->game;
#line 474 "../src/sudoku-view.vala"
				_tmp51_ = _tmp50_->board;
#line 474 "../src/sudoku-view.vala"
				_tmp53_ = sudoku_board_get_possibilities_as_bool_array (_tmp51_, self->priv->row, self->priv->col, &_tmp52_);
#line 474 "../src/sudoku-view.vala"
				marks = (g_free (marks), NULL);
#line 474 "../src/sudoku-view.vala"
				marks = _tmp53_;
#line 474 "../src/sudoku-view.vala"
				marks_length1 = _tmp52_;
#line 474 "../src/sudoku-view.vala"
				_marks_size_ = marks_length1;
#line 2205 "sudoku-view.c"
				{
					gint num = 0;
#line 475 "../src/sudoku-view.vala"
					num = 1;
#line 2210 "sudoku-view.c"
					{
						gboolean _tmp54_ = FALSE;
#line 475 "../src/sudoku-view.vala"
						_tmp54_ = TRUE;
#line 475 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2217 "sudoku-view.c"
							gboolean* _tmp56_;
							gint _tmp56__length1;
							gboolean* _tmp57_;
							gint _tmp57__length1;
							gboolean _tmp58_;
#line 475 "../src/sudoku-view.vala"
							if (!_tmp54_) {
#line 2225 "sudoku-view.c"
								gint _tmp55_;
#line 475 "../src/sudoku-view.vala"
								_tmp55_ = num;
#line 475 "../src/sudoku-view.vala"
								num = _tmp55_ + 1;
#line 2231 "sudoku-view.c"
							}
#line 475 "../src/sudoku-view.vala"
							_tmp54_ = FALSE;
#line 475 "../src/sudoku-view.vala"
							_tmp56_ = marks;
#line 475 "../src/sudoku-view.vala"
							_tmp56__length1 = marks_length1;
#line 475 "../src/sudoku-view.vala"
							if (!(num <= _tmp56__length1)) {
#line 475 "../src/sudoku-view.vala"
								break;
#line 2243 "sudoku-view.c"
							}
#line 477 "../src/sudoku-view.vala"
							_tmp57_ = marks;
#line 477 "../src/sudoku-view.vala"
							_tmp57__length1 = marks_length1;
#line 477 "../src/sudoku-view.vala"
							_tmp58_ = _tmp57_[num - 1];
#line 477 "../src/sudoku-view.vala"
							if (_tmp58_) {
#line 2253 "sudoku-view.c"
								SudokuGame* _tmp59_;
								SudokuBoard* _tmp60_;
#line 479 "../src/sudoku-view.vala"
								_tmp59_ = self->priv->game;
#line 479 "../src/sudoku-view.vala"
								_tmp60_ = _tmp59_->board;
#line 479 "../src/sudoku-view.vala"
								sudoku_board_enable_earmark (_tmp60_, self->priv->row, self->priv->col, num);
#line 2262 "sudoku-view.c"
							}
						}
					}
				}
			}
#line 483 "../src/sudoku-view.vala"
			self->priv->initialized_earmarks = TRUE;
#line 2270 "sudoku-view.c"
		}
#line 486 "../src/sudoku-view.vala"
		_tmp61_ = self->priv->game;
#line 486 "../src/sudoku-view.vala"
		_tmp62_ = _tmp61_->board;
#line 486 "../src/sudoku-view.vala"
		_tmp64_ = sudoku_board_get_earmarks (_tmp62_, self->priv->row, self->priv->col, &_tmp63_);
#line 486 "../src/sudoku-view.vala"
		marks = (g_free (marks), NULL);
#line 486 "../src/sudoku-view.vala"
		marks = _tmp64_;
#line 486 "../src/sudoku-view.vala"
		marks_length1 = _tmp63_;
#line 486 "../src/sudoku-view.vala"
		_marks_size_ = marks_length1;
#line 2286 "sudoku-view.c"
	} else {
		gint _tmp65_;
		gint _tmp66_;
#line 488 "../src/sudoku-view.vala"
		_tmp65_ = sudoku_cell_view_get_value (self);
#line 488 "../src/sudoku-view.vala"
		_tmp66_ = _tmp65_;
#line 488 "../src/sudoku-view.vala"
		if (_tmp66_ == 0) {
#line 2296 "sudoku-view.c"
			SudokuGame* _tmp67_;
			SudokuBoard* _tmp68_;
			gint _tmp69_ = 0;
			gboolean* _tmp70_;
#line 490 "../src/sudoku-view.vala"
			_tmp67_ = self->priv->game;
#line 490 "../src/sudoku-view.vala"
			_tmp68_ = _tmp67_->board;
#line 490 "../src/sudoku-view.vala"
			_tmp70_ = sudoku_board_get_possibilities_as_bool_array (_tmp68_, self->priv->row, self->priv->col, &_tmp69_);
#line 490 "../src/sudoku-view.vala"
			marks = (g_free (marks), NULL);
#line 490 "../src/sudoku-view.vala"
			marks = _tmp70_;
#line 490 "../src/sudoku-view.vala"
			marks_length1 = _tmp69_;
#line 490 "../src/sudoku-view.vala"
			_marks_size_ = marks_length1;
#line 2315 "sudoku-view.c"
		}
	}
#line 493 "../src/sudoku-view.vala"
	_tmp71_ = marks;
#line 493 "../src/sudoku-view.vala"
	_tmp71__length1 = marks_length1;
#line 493 "../src/sudoku-view.vala"
	if (_tmp71_ != NULL) {
#line 2324 "sudoku-view.c"
		gdouble possibility_size = 0.0;
		gdouble height = 0.0;
		SudokuGame* _tmp72_;
		SudokuBoard* _tmp73_;
		gint _tmp74_;
		gint _tmp75_;
		gdouble width = 0.0;
		SudokuGame* _tmp76_;
		SudokuBoard* _tmp77_;
		gint _tmp78_;
		gint _tmp79_;
		gint num = 0;
#line 495 "../src/sudoku-view.vala"
		possibility_size = (gtk_widget_get_allocated_height ((GtkWidget*) self) / self->priv->size_ratio) / 2;
#line 496 "../src/sudoku-view.vala"
		cairo_set_font_size (c, possibility_size);
#line 498 "../src/sudoku-view.vala"
		_tmp72_ = self->priv->game;
#line 498 "../src/sudoku-view.vala"
		_tmp73_ = _tmp72_->board;
#line 498 "../src/sudoku-view.vala"
		_tmp74_ = sudoku_board_get_block_rows (_tmp73_);
#line 498 "../src/sudoku-view.vala"
		_tmp75_ = _tmp74_;
#line 498 "../src/sudoku-view.vala"
		height = ((gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self)) / _tmp75_;
#line 499 "../src/sudoku-view.vala"
		_tmp76_ = self->priv->game;
#line 499 "../src/sudoku-view.vala"
		_tmp77_ = _tmp76_->board;
#line 499 "../src/sudoku-view.vala"
		_tmp78_ = sudoku_board_get_block_cols (_tmp77_);
#line 499 "../src/sudoku-view.vala"
		_tmp79_ = _tmp78_;
#line 499 "../src/sudoku-view.vala"
		width = ((gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self)) / _tmp79_;
#line 501 "../src/sudoku-view.vala"
		num = 0;
#line 2363 "sudoku-view.c"
		{
			gint row_tmp = 0;
#line 502 "../src/sudoku-view.vala"
			row_tmp = 0;
#line 2368 "sudoku-view.c"
			{
				gboolean _tmp80_ = FALSE;
#line 502 "../src/sudoku-view.vala"
				_tmp80_ = TRUE;
#line 502 "../src/sudoku-view.vala"
				while (TRUE) {
#line 2375 "sudoku-view.c"
					SudokuGame* _tmp82_;
					SudokuBoard* _tmp83_;
					gint _tmp84_;
					gint _tmp85_;
#line 502 "../src/sudoku-view.vala"
					if (!_tmp80_) {
#line 2382 "sudoku-view.c"
						gint _tmp81_;
#line 502 "../src/sudoku-view.vala"
						_tmp81_ = row_tmp;
#line 502 "../src/sudoku-view.vala"
						row_tmp = _tmp81_ + 1;
#line 2388 "sudoku-view.c"
					}
#line 502 "../src/sudoku-view.vala"
					_tmp80_ = FALSE;
#line 502 "../src/sudoku-view.vala"
					_tmp82_ = self->priv->game;
#line 502 "../src/sudoku-view.vala"
					_tmp83_ = _tmp82_->board;
#line 502 "../src/sudoku-view.vala"
					_tmp84_ = sudoku_board_get_block_rows (_tmp83_);
#line 502 "../src/sudoku-view.vala"
					_tmp85_ = _tmp84_;
#line 502 "../src/sudoku-view.vala"
					if (!(row_tmp < _tmp85_)) {
#line 502 "../src/sudoku-view.vala"
						break;
#line 2404 "sudoku-view.c"
					}
					{
						gint col_tmp = 0;
#line 504 "../src/sudoku-view.vala"
						col_tmp = 0;
#line 2410 "sudoku-view.c"
						{
							gboolean _tmp86_ = FALSE;
#line 504 "../src/sudoku-view.vala"
							_tmp86_ = TRUE;
#line 504 "../src/sudoku-view.vala"
							while (TRUE) {
#line 2417 "sudoku-view.c"
								SudokuGame* _tmp88_;
								SudokuBoard* _tmp89_;
								gint _tmp90_;
								gint _tmp91_;
								gint _tmp92_;
								gboolean* _tmp93_;
								gint _tmp93__length1;
								gboolean _tmp94_;
#line 504 "../src/sudoku-view.vala"
								if (!_tmp86_) {
#line 2428 "sudoku-view.c"
									gint _tmp87_;
#line 504 "../src/sudoku-view.vala"
									_tmp87_ = col_tmp;
#line 504 "../src/sudoku-view.vala"
									col_tmp = _tmp87_ + 1;
#line 2434 "sudoku-view.c"
								}
#line 504 "../src/sudoku-view.vala"
								_tmp86_ = FALSE;
#line 504 "../src/sudoku-view.vala"
								_tmp88_ = self->priv->game;
#line 504 "../src/sudoku-view.vala"
								_tmp89_ = _tmp88_->board;
#line 504 "../src/sudoku-view.vala"
								_tmp90_ = sudoku_board_get_block_cols (_tmp89_);
#line 504 "../src/sudoku-view.vala"
								_tmp91_ = _tmp90_;
#line 504 "../src/sudoku-view.vala"
								if (!(col_tmp < _tmp91_)) {
#line 504 "../src/sudoku-view.vala"
									break;
#line 2450 "sudoku-view.c"
								}
#line 506 "../src/sudoku-view.vala"
								_tmp92_ = num;
#line 506 "../src/sudoku-view.vala"
								num = _tmp92_ + 1;
#line 508 "../src/sudoku-view.vala"
								_tmp93_ = marks;
#line 508 "../src/sudoku-view.vala"
								_tmp93__length1 = marks_length1;
#line 508 "../src/sudoku-view.vala"
								_tmp94_ = _tmp93_[num - 1];
#line 508 "../src/sudoku-view.vala"
								if (_tmp94_) {
#line 2464 "sudoku-view.c"
									gboolean _tmp95_ = FALSE;
									gchar* text = NULL;
									gchar* _tmp98_;
									SudokuGame* _tmp99_;
									SudokuBoard* _tmp100_;
									gint _tmp101_;
									gint _tmp102_;
									const gchar* _tmp103_;
#line 510 "../src/sudoku-view.vala"
									if (self->priv->_show_warnings) {
#line 2475 "sudoku-view.c"
										SudokuGame* _tmp96_;
										SudokuBoard* _tmp97_;
#line 510 "../src/sudoku-view.vala"
										_tmp96_ = self->priv->game;
#line 510 "../src/sudoku-view.vala"
										_tmp97_ = _tmp96_->board;
#line 510 "../src/sudoku-view.vala"
										_tmp95_ = !sudoku_board_is_possible (_tmp97_, self->priv->row, self->priv->col, num);
#line 2484 "sudoku-view.c"
									} else {
#line 510 "../src/sudoku-view.vala"
										_tmp95_ = FALSE;
#line 2488 "sudoku-view.c"
									}
#line 510 "../src/sudoku-view.vala"
									if (_tmp95_) {
#line 511 "../src/sudoku-view.vala"
										cairo_set_source_rgb (c, 1.0, 0.0, 0.0);
#line 2494 "sudoku-view.c"
									} else {
#line 513 "../src/sudoku-view.vala"
										cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
#line 2498 "sudoku-view.c"
									}
#line 515 "../src/sudoku-view.vala"
									_tmp98_ = g_strdup_printf ("%d", num);
#line 515 "../src/sudoku-view.vala"
									text = _tmp98_;
#line 517 "../src/sudoku-view.vala"
									cairo_save (c);
#line 518 "../src/sudoku-view.vala"
									_tmp99_ = self->priv->game;
#line 518 "../src/sudoku-view.vala"
									_tmp100_ = _tmp99_->board;
#line 518 "../src/sudoku-view.vala"
									_tmp101_ = sudoku_board_get_block_rows (_tmp100_);
#line 518 "../src/sudoku-view.vala"
									_tmp102_ = _tmp101_;
#line 518 "../src/sudoku-view.vala"
									cairo_translate (c, col_tmp * width, ((_tmp102_ - row_tmp) - 1) * height);
#line 519 "../src/sudoku-view.vala"
									_tmp103_ = text;
#line 519 "../src/sudoku-view.vala"
									sudoku_cell_view_print_centered (self, c, _tmp103_, width, height);
#line 520 "../src/sudoku-view.vala"
									cairo_restore (c);
#line 508 "../src/sudoku-view.vala"
									_g_free0 (text);
#line 2524 "sudoku-view.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 526 "../src/sudoku-view.vala"
	if (self->priv->_show_warnings) {
#line 2535 "sudoku-view.c"
		gboolean _tmp105_ = FALSE;
		gint _tmp106_;
		gint _tmp107_;
#line 526 "../src/sudoku-view.vala"
		_tmp106_ = sudoku_cell_view_get_value (self);
#line 526 "../src/sudoku-view.vala"
		_tmp107_ = _tmp106_;
#line 526 "../src/sudoku-view.vala"
		if (_tmp107_ == 0) {
#line 2545 "sudoku-view.c"
			SudokuGame* _tmp108_;
			SudokuBoard* _tmp109_;
#line 526 "../src/sudoku-view.vala"
			_tmp108_ = self->priv->game;
#line 526 "../src/sudoku-view.vala"
			_tmp109_ = _tmp108_->board;
#line 526 "../src/sudoku-view.vala"
			_tmp105_ = sudoku_board_count_possibilities (_tmp109_, self->priv->row, self->priv->col) == 0;
#line 2554 "sudoku-view.c"
		} else {
#line 526 "../src/sudoku-view.vala"
			_tmp105_ = FALSE;
#line 2558 "sudoku-view.c"
		}
#line 526 "../src/sudoku-view.vala"
		_tmp104_ = _tmp105_;
#line 2562 "sudoku-view.c"
	} else {
#line 526 "../src/sudoku-view.vala"
		_tmp104_ = FALSE;
#line 2566 "sudoku-view.c"
	}
#line 526 "../src/sudoku-view.vala"
	if (_tmp104_) {
#line 528 "../src/sudoku-view.vala"
		cairo_set_font_size (c, gtk_widget_get_allocated_height ((GtkWidget*) self) / self->priv->size_ratio);
#line 529 "../src/sudoku-view.vala"
		cairo_set_source_rgb (c, 1.0, 0.0, 0.0);
#line 530 "../src/sudoku-view.vala"
		sudoku_cell_view_print_centered (self, c, "X", (gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self), (gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self));
#line 2576 "sudoku-view.c"
	}
#line 533 "../src/sudoku-view.vala"
	result = FALSE;
#line 533 "../src/sudoku-view.vala"
	marks = (g_free (marks), NULL);
#line 533 "../src/sudoku-view.vala"
	return result;
#line 2584 "sudoku-view.c"
}

static void
sudoku_cell_view_print_centered (SudokuCellView* self,
                                 cairo_t* c,
                                 const gchar* text,
                                 gdouble width,
                                 gdouble height)
{
	cairo_font_extents_t font_extents = {0};
	cairo_font_extents_t _tmp0_ = {0};
	cairo_text_extents_t text_extents = {0};
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp3_;
	cairo_font_extents_t _tmp4_;
	cairo_font_extents_t _tmp5_;
#line 536 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 536 "../src/sudoku-view.vala"
	g_return_if_fail (c != NULL);
#line 536 "../src/sudoku-view.vala"
	g_return_if_fail (text != NULL);
#line 539 "../src/sudoku-view.vala"
	cairo_font_extents (c, &_tmp0_);
#line 539 "../src/sudoku-view.vala"
	font_extents = _tmp0_;
#line 542 "../src/sudoku-view.vala"
	cairo_text_extents (c, text, &_tmp1_);
#line 542 "../src/sudoku-view.vala"
	text_extents = _tmp1_;
#line 544 "../src/sudoku-view.vala"
	_tmp2_ = text_extents;
#line 544 "../src/sudoku-view.vala"
	_tmp3_ = text_extents;
#line 544 "../src/sudoku-view.vala"
	_tmp4_ = font_extents;
#line 544 "../src/sudoku-view.vala"
	_tmp5_ = font_extents;
#line 544 "../src/sudoku-view.vala"
	cairo_move_to (c, ((width - _tmp2_.width) / 2) - _tmp3_.x_bearing, ((height + _tmp4_.height) / 2) - _tmp5_.descent);
#line 548 "../src/sudoku-view.vala"
	cairo_show_text (c, text);
#line 2628 "sudoku-view.c"
}

void
sudoku_cell_view_cell_changed_cb (SudokuCellView* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val)
{
	gboolean _tmp0_ = FALSE;
#line 551 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 553 "../src/sudoku-view.vala"
	if (row == self->priv->row) {
#line 553 "../src/sudoku-view.vala"
		_tmp0_ = col == self->priv->col;
#line 2645 "sudoku-view.c"
	} else {
#line 553 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 2649 "sudoku-view.c"
	}
#line 553 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 555 "../src/sudoku-view.vala"
		sudoku_cell_view_set_value (self, new_val);
#line 556 "../src/sudoku-view.vala"
		g_object_notify ((GObject*) self, "value");
#line 2657 "sudoku-view.c"
	}
}

void
sudoku_cell_view_clear (SudokuCellView* self)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
#line 560 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 562 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 562 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 562 "../src/sudoku-view.vala"
	sudoku_board_disable_all_earmarks (_tmp1_, self->priv->row, self->priv->col);
#line 2674 "sudoku-view.c"
}

static gboolean
sudoku_cell_view_warn_incorrect_solution (SudokuCellView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 568 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 574 "../src/sudoku-view.vala"
	if (self->priv->_show_warnings) {
#line 2690 "sudoku-view.c"
		GtkPopover* _tmp5_;
#line 575 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->popover;
#line 575 "../src/sudoku-view.vala"
		_tmp4_ = _tmp5_ == NULL;
#line 2696 "sudoku-view.c"
	} else {
#line 574 "../src/sudoku-view.vala"
		_tmp4_ = FALSE;
#line 2700 "sudoku-view.c"
	}
#line 574 "../src/sudoku-view.vala"
	if (_tmp4_) {
#line 2704 "sudoku-view.c"
		GtkPopover* _tmp6_;
#line 575 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->earmark_popover;
#line 575 "../src/sudoku-view.vala"
		_tmp3_ = _tmp6_ == NULL;
#line 2710 "sudoku-view.c"
	} else {
#line 574 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 2714 "sudoku-view.c"
	}
#line 574 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 576 "../src/sudoku-view.vala"
		_tmp2_ = !self->priv->left_control;
#line 2720 "sudoku-view.c"
	} else {
#line 574 "../src/sudoku-view.vala"
		_tmp2_ = FALSE;
#line 2724 "sudoku-view.c"
	}
#line 574 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 576 "../src/sudoku-view.vala"
		_tmp1_ = !self->priv->right_control;
#line 2730 "sudoku-view.c"
	} else {
#line 574 "../src/sudoku-view.vala"
		_tmp1_ = FALSE;
#line 2734 "sudoku-view.c"
	}
#line 574 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 2738 "sudoku-view.c"
		SudokuGame* _tmp7_;
		SudokuBoard* _tmp8_;
#line 577 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->game;
#line 577 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_->board;
#line 577 "../src/sudoku-view.vala"
		_tmp0_ = sudoku_board_solved (_tmp8_);
#line 2747 "sudoku-view.c"
	} else {
#line 574 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 2751 "sudoku-view.c"
	}
#line 574 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 574 "../src/sudoku-view.vala"
	return result;
#line 2757 "sudoku-view.c"
}

gint
sudoku_cell_view_get_value (SudokuCellView* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
#line 45 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 45 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 45 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 45 "../src/sudoku-view.vala"
	result = sudoku_board_get (_tmp1_, self->priv->row, self->priv->col);
#line 45 "../src/sudoku-view.vala"
	return result;
#line 2776 "sudoku-view.c"
}

void
sudoku_cell_view_set_value (SudokuCellView* self,
                            gint value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuGame* _tmp7_;
	SudokuBoard* _tmp8_;
	SudokuGame* _tmp9_;
#line 46 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_cell_view_get_is_fixed (self);
#line 48 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 48 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 2796 "sudoku-view.c"
		SudokuGame* _tmp2_;
#line 50 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->game;
#line 50 "../src/sudoku-view.vala"
		if (_tmp2_->mode == GAME_MODE_PLAY) {
#line 51 "../src/sudoku-view.vala"
			return;
#line 2804 "sudoku-view.c"
		}
	}
#line 53 "../src/sudoku-view.vala"
	if (value == 0) {
#line 2809 "sudoku-view.c"
		SudokuGame* _tmp3_;
		SudokuBoard* _tmp4_;
		SudokuGame* _tmp6_;
#line 55 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->game;
#line 55 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_->board;
#line 55 "../src/sudoku-view.vala"
		if (sudoku_board_get (_tmp4_, self->priv->row, self->priv->col) != 0) {
#line 2819 "sudoku-view.c"
			SudokuGame* _tmp5_;
#line 56 "../src/sudoku-view.vala"
			_tmp5_ = self->priv->game;
#line 56 "../src/sudoku-view.vala"
			sudoku_game_remove (_tmp5_, self->priv->row, self->priv->col);
#line 2825 "sudoku-view.c"
		}
#line 57 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->game;
#line 57 "../src/sudoku-view.vala"
		if (_tmp6_->mode == GAME_MODE_PLAY) {
#line 58 "../src/sudoku-view.vala"
			return;
#line 2833 "sudoku-view.c"
		}
	}
#line 60 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->game;
#line 60 "../src/sudoku-view.vala"
	_tmp8_ = _tmp7_->board;
#line 60 "../src/sudoku-view.vala"
	if (value == sudoku_board_get (_tmp8_, self->priv->row, self->priv->col)) {
#line 61 "../src/sudoku-view.vala"
		return;
#line 2844 "sudoku-view.c"
	}
#line 63 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->game;
#line 63 "../src/sudoku-view.vala"
	sudoku_game_insert (_tmp9_, self->priv->row, self->priv->col, value);
#line 46 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_VALUE_PROPERTY]);
#line 2852 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_is_fixed (SudokuCellView* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gboolean _tmp3_;
#line 69 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 69 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 69 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_->is_fixed;
#line 69 "../src/sudoku-view.vala"
	_tmp2__length1 = _tmp1_->is_fixed_length1;
#line 69 "../src/sudoku-view.vala"
	_tmp2__length2 = _tmp1_->is_fixed_length2;
#line 69 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_[(self->priv->row * _tmp2__length2) + self->priv->col];
#line 69 "../src/sudoku-view.vala"
	result = _tmp3_;
#line 69 "../src/sudoku-view.vala"
	return result;
#line 2883 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_show_possibilities (SudokuCellView* self)
{
	gboolean result;
#line 75 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 75 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 75 "../src/sudoku-view.vala"
	return result;
#line 2896 "sudoku-view.c"
}

void
sudoku_cell_view_set_show_possibilities (SudokuCellView* self,
                                         gboolean value)
{
#line 76 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 79 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 76 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 2911 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_initialize_earmarks (SudokuCellView* self)
{
	gboolean result;
#line 86 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 86 "../src/sudoku-view.vala"
	result = self->priv->_initialize_earmarks;
#line 86 "../src/sudoku-view.vala"
	return result;
#line 2924 "sudoku-view.c"
}

void
sudoku_cell_view_set_initialize_earmarks (SudokuCellView* self,
                                          gboolean value)
{
#line 87 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = value;
#line 90 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 87 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY]);
#line 2939 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_show_warnings (SudokuCellView* self)
{
	gboolean result;
#line 97 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 97 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 97 "../src/sudoku-view.vala"
	return result;
#line 2952 "sudoku-view.c"
}

void
sudoku_cell_view_set_show_warnings (SudokuCellView* self,
                                    gboolean value)
{
#line 98 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 101 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 98 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 2967 "sudoku-view.c"
}

gboolean
sudoku_cell_view_get_selected (SudokuCellView* self)
{
	gboolean result;
#line 105 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 105 "../src/sudoku-view.vala"
	result = self->priv->_selected;
#line 105 "../src/sudoku-view.vala"
	return result;
#line 2980 "sudoku-view.c"
}

void
sudoku_cell_view_set_selected (SudokuCellView* self,
                               gboolean value)
{
	gboolean old_value;
#line 105 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/sudoku-view.vala"
	old_value = sudoku_cell_view_get_selected (self);
#line 105 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 105 "../src/sudoku-view.vala"
		self->priv->_selected = value;
#line 105 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SELECTED_PROPERTY]);
#line 2998 "sudoku-view.c"
	}
}

gboolean
sudoku_cell_view_get_highlighted_background (SudokuCellView* self)
{
	gboolean result;
#line 106 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 106 "../src/sudoku-view.vala"
	result = self->priv->_highlighted_background;
#line 106 "../src/sudoku-view.vala"
	return result;
#line 3012 "sudoku-view.c"
}

void
sudoku_cell_view_set_highlighted_background (SudokuCellView* self,
                                             gboolean value)
{
	gboolean old_value;
#line 106 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/sudoku-view.vala"
	old_value = sudoku_cell_view_get_highlighted_background (self);
#line 106 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 106 "../src/sudoku-view.vala"
		self->priv->_highlighted_background = value;
#line 106 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY]);
#line 3030 "sudoku-view.c"
	}
}

gboolean
sudoku_cell_view_get_highlighted_value (SudokuCellView* self)
{
	gboolean result;
#line 107 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "../src/sudoku-view.vala"
	result = self->priv->_highlighted_value;
#line 107 "../src/sudoku-view.vala"
	return result;
#line 3044 "sudoku-view.c"
}

void
sudoku_cell_view_set_highlighted_value (SudokuCellView* self,
                                        gboolean value)
{
	gboolean old_value;
#line 107 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/sudoku-view.vala"
	old_value = sudoku_cell_view_get_highlighted_value (self);
#line 107 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 107 "../src/sudoku-view.vala"
		self->priv->_highlighted_value = value;
#line 107 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY]);
#line 3062 "sudoku-view.c"
	}
}

static void
sudoku_cell_view_class_init (SudokuCellViewClass * klass,
                             gpointer klass_data)
{
#line 25 "../src/sudoku-view.vala"
	sudoku_cell_view_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCellView_private_offset);
#line 25 "../src/sudoku-view.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) sudoku_cell_view_real_button_press_event;
#line 25 "../src/sudoku-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) sudoku_cell_view_real_draw;
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_view_get_property;
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_view_set_property;
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_view_finalize;
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_VALUE_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SELECTED_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY] = g_param_spec_boolean ("highlighted-background", "highlighted-background", "highlighted-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY] = g_param_spec_boolean ("highlighted-value", "highlighted-value", "highlighted-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3100 "sudoku-view.c"
}

static void
sudoku_cell_view_instance_init (SudokuCellView * self,
                                gpointer klass)
{
#line 25 "../src/sudoku-view.vala"
	self->priv = sudoku_cell_view_get_instance_private (self);
#line 27 "../src/sudoku-view.vala"
	self->priv->size_ratio = (gdouble) 2;
#line 94 "../src/sudoku-view.vala"
	self->priv->_show_warnings = TRUE;
#line 3113 "sudoku-view.c"
}

static void
sudoku_cell_view_finalize (GObject * obj)
{
	SudokuCellView * self;
#line 25 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
#line 29 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->popover);
#line 30 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_popover);
#line 32 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 109 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->number_picker);
#line 110 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_picker);
#line 112 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_cell_view_parent_class)->finalize (obj);
#line 3136 "sudoku-view.c"
}

static GType
sudoku_cell_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCellView), 0, (GInstanceInitFunc) sudoku_cell_view_instance_init, NULL };
	GType sudoku_cell_view_type_id;
	sudoku_cell_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "SudokuCellView", &g_define_type_info, 0);
	SudokuCellView_private_offset = g_type_add_instance_private (sudoku_cell_view_type_id, sizeof (SudokuCellViewPrivate));
	return sudoku_cell_view_type_id;
}

GType
sudoku_cell_view_get_type (void)
{
	static volatile gsize sudoku_cell_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_view_type_id__once)) {
		GType sudoku_cell_view_type_id;
		sudoku_cell_view_type_id = sudoku_cell_view_get_type_once ();
		g_once_init_leave (&sudoku_cell_view_type_id__once, sudoku_cell_view_type_id);
	}
	return sudoku_cell_view_type_id__once;
}

static void
_vala_sudoku_cell_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	SudokuCellView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
#line 25 "../src/sudoku-view.vala"
	switch (property_id) {
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_VALUE_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_cell_view_get_value (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_is_fixed (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_show_possibilities (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_initialize_earmarks (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_show_warnings (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SELECTED_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_selected (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_highlighted_background (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_highlighted_value (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 3219 "sudoku-view.c"
		default:
#line 25 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/sudoku-view.vala"
		break;
#line 3225 "sudoku-view.c"
	}
}

static void
_vala_sudoku_cell_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	SudokuCellView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
#line 25 "../src/sudoku-view.vala"
	switch (property_id) {
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_VALUE_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_value (self, g_value_get_int (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_show_warnings (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SELECTED_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_selected (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_highlighted_background (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_HIGHLIGHTED_VALUE_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_highlighted_value (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 3281 "sudoku-view.c"
		default:
#line 25 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/sudoku-view.vala"
		break;
#line 3287 "sudoku-view.c"
	}
}

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 599 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 601 "../src/sudoku-view.vala"
	if (self->priv->selected_row >= 0) {
#line 601 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->selected_col >= 0;
#line 3310 "sudoku-view.c"
	} else {
#line 601 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 3314 "sudoku-view.c"
	}
#line 601 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 3318 "sudoku-view.c"
		SudokuCellView** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCellView* _tmp2_;
		SudokuCellView** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		SudokuCellView* _tmp4_;
#line 603 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 603 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 603 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 603 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(self->priv->selected_row * _tmp1__length2) + self->priv->selected_col];
#line 603 "../src/sudoku-view.vala"
		sudoku_cell_view_set_selected (_tmp2_, FALSE);
#line 604 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->cells;
#line 604 "../src/sudoku-view.vala"
		_tmp3__length1 = self->priv->cells_length1;
#line 604 "../src/sudoku-view.vala"
		_tmp3__length2 = self->priv->cells_length2;
#line 604 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_[(self->priv->selected_row * _tmp3__length2) + self->priv->selected_col];
#line 604 "../src/sudoku-view.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp4_);
#line 3347 "sudoku-view.c"
	}
#line 606 "../src/sudoku-view.vala"
	self->priv->selected_row = cell_row;
#line 607 "../src/sudoku-view.vala"
	self->priv->selected_col = cell_col;
#line 608 "../src/sudoku-view.vala"
	if (self->priv->selected_row >= 0) {
#line 608 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->selected_col >= 0;
#line 3357 "sudoku-view.c"
	} else {
#line 608 "../src/sudoku-view.vala"
		_tmp5_ = FALSE;
#line 3361 "sudoku-view.c"
	}
#line 608 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 3365 "sudoku-view.c"
		SudokuCellView** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuCellView* _tmp7_;
#line 610 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->cells;
#line 610 "../src/sudoku-view.vala"
		_tmp6__length1 = self->priv->cells_length1;
#line 610 "../src/sudoku-view.vala"
		_tmp6__length2 = self->priv->cells_length2;
#line 610 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_[(self->priv->selected_row * _tmp6__length2) + self->priv->selected_col];
#line 610 "../src/sudoku-view.vala"
		sudoku_cell_view_set_selected (_tmp7_, TRUE);
#line 3380 "sudoku-view.c"
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 614 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 614 "../src/sudoku-view.vala"
	return _data9_;
#line 3391 "sudoku-view.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 614 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 3401 "sudoku-view.c"
		SudokuView* self;
#line 614 "../src/sudoku-view.vala"
		self = _data9_->self;
#line 614 "../src/sudoku-view.vala"
		_g_object_unref0 (_data9_->game);
#line 614 "../src/sudoku-view.vala"
		_g_object_unref0 (self);
#line 614 "../src/sudoku-view.vala"
		g_slice_free (Block9Data, _data9_);
#line 3411 "sudoku-view.c"
	}
}

static gboolean
_sudoku_view_draw_board_gtk_widget_draw (GtkWidget* _sender,
                                         cairo_t* cr,
                                         gpointer self)
{
	gboolean result;
	result = sudoku_view_draw_board ((SudokuView*) self, cr);
#line 624 "../src/sudoku-view.vala"
	return result;
#line 3424 "sudoku-view.c"
}

static void
__lambda13_ (SudokuView* self)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 631 "../src/sudoku-view.vala"
	_tmp0_ = self->game;
#line 631 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 631 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 631 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 3441 "sudoku-view.c"
		GtkDrawingArea* _tmp3_;
#line 632 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->drawing;
#line 632 "../src/sudoku-view.vala"
		gtk_widget_show ((GtkWidget*) _tmp3_);
#line 3447 "sudoku-view.c"
	} else {
		GtkDrawingArea* _tmp4_;
#line 634 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->drawing;
#line 634 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 3454 "sudoku-view.c"
	}
}

static void
___lambda13__sudoku_game_paused_changed (SudokuGame* _sender,
                                         gpointer self)
{
#line 630 "../src/sudoku-view.vala"
	__lambda13_ ((SudokuView*) self);
#line 3464 "sudoku-view.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 669 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 669 "../src/sudoku-view.vala"
	return _data10_;
#line 3474 "sudoku-view.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 669 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 3484 "sudoku-view.c"
		SudokuView* self;
#line 669 "../src/sudoku-view.vala"
		self = _data10_->_data9_->self;
#line 669 "../src/sudoku-view.vala"
		block9_data_unref (_data10_->_data9_);
#line 669 "../src/sudoku-view.vala"
		_data10_->_data9_ = NULL;
#line 669 "../src/sudoku-view.vala"
		g_slice_free (Block10Data, _data10_);
#line 3494 "sudoku-view.c"
	}
}

static gboolean
________lambda14_ (Block10Data* _data10_)
{
	Block9Data* _data9_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 675 "../src/sudoku-view.vala"
	_data9_ = _data10_->_data9_;
#line 675 "../src/sudoku-view.vala"
	self = _data9_->self;
#line 676 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_game_get_paused (_data9_->game);
#line 676 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 676 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 677 "../src/sudoku-view.vala"
		result = FALSE;
#line 677 "../src/sudoku-view.vala"
		return result;
#line 3520 "sudoku-view.c"
	}
#line 679 "../src/sudoku-view.vala"
	sudoku_view_set_selected (self, _data10_->cell_row, _data10_->cell_col);
#line 680 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 681 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 683 "../src/sudoku-view.vala"
	result = FALSE;
#line 683 "../src/sudoku-view.vala"
	return result;
#line 3532 "sudoku-view.c"
}

static gboolean
_________lambda14__gtk_widget_focus_in_event (GtkWidget* _sender,
                                              GdkEventFocus* event,
                                              gpointer self)
{
	gboolean result;
	result = ________lambda14_ (self);
#line 675 "../src/sudoku-view.vala"
	return result;
#line 3544 "sudoku-view.c"
}

static gboolean
________lambda15_ (Block10Data* _data10_)
{
	Block9Data* _data9_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 686 "../src/sudoku-view.vala"
	_data9_ = _data10_->_data9_;
#line 686 "../src/sudoku-view.vala"
	self = _data9_->self;
#line 687 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_game_get_paused (_data9_->game);
#line 687 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 687 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 688 "../src/sudoku-view.vala"
		result = FALSE;
#line 688 "../src/sudoku-view.vala"
		return result;
#line 3569 "sudoku-view.c"
	}
#line 690 "../src/sudoku-view.vala"
	sudoku_view_set_selected (self, -1, -1);
#line 691 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 692 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 694 "../src/sudoku-view.vala"
	result = FALSE;
#line 694 "../src/sudoku-view.vala"
	return result;
#line 3581 "sudoku-view.c"
}

static gboolean
_________lambda15__gtk_widget_focus_out_event (GtkWidget* _sender,
                                               GdkEventFocus* event,
                                               gpointer self)
{
	gboolean result;
	result = ________lambda15_ (self);
#line 686 "../src/sudoku-view.vala"
	return result;
#line 3593 "sudoku-view.c"
}

static void
________lambda16_ (Block10Data* _data10_,
                   GObject* s,
                   GParamSpec* p)
{
	Block9Data* _data9_;
	SudokuView* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 697 "../src/sudoku-view.vala"
	_data9_ = _data10_->_data9_;
#line 697 "../src/sudoku-view.vala"
	self = _data9_->self;
#line 697 "../src/sudoku-view.vala"
	g_return_if_fail (s != NULL);
#line 697 "../src/sudoku-view.vala"
	g_return_if_fail (p != NULL);
#line 698 "../src/sudoku-view.vala"
	if (self->priv->_show_possibilities) {
#line 698 "../src/sudoku-view.vala"
		_tmp2_ = TRUE;
#line 3618 "sudoku-view.c"
	} else {
#line 698 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_show_warnings;
#line 3622 "sudoku-view.c"
	}
#line 698 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 698 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3628 "sudoku-view.c"
	} else {
		SudokuBoard* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 698 "../src/sudoku-view.vala"
		_tmp3_ = _data9_->game->board;
#line 698 "../src/sudoku-view.vala"
		_tmp4_ = sudoku_board_get_broken (_tmp3_);
#line 698 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_;
#line 698 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_;
#line 3641 "sudoku-view.c"
	}
#line 698 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 698 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 3647 "sudoku-view.c"
	} else {
#line 698 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->previous_board_broken_state;
#line 3651 "sudoku-view.c"
	}
#line 698 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 3655 "sudoku-view.c"
		SudokuBoard* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 699 "../src/sudoku-view.vala"
		_tmp6_ = _data9_->game->board;
#line 699 "../src/sudoku-view.vala"
		_tmp7_ = sudoku_board_get_broken (_tmp6_);
#line 699 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_;
#line 699 "../src/sudoku-view.vala"
		self->priv->previous_board_broken_state = _tmp8_;
#line 3667 "sudoku-view.c"
	}
#line 701 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 703 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 3673 "sudoku-view.c"
}

static void
_________lambda16__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 697 "../src/sudoku-view.vala"
	________lambda16_ (self, _sender, pspec);
#line 3683 "sudoku-view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game)
{
	SudokuView * self = NULL;
	Block9Data* _data9_;
	SudokuGame* _tmp0_;
	GtkOverlay* _tmp1_;
	GtkOverlay* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GtkDrawingArea* _tmp4_;
	GtkGrid* _tmp5_;
	SudokuGame* _tmp8_;
	SudokuGame* _tmp9_;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp10_;
	GtkCssProvider* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	GtkGrid* _tmp15_;
	GtkGrid* _tmp16_;
	GtkGrid* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkGrid* _tmp19_;
	GtkStyleContext* _tmp20_;
	GtkCssProvider* _tmp21_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	SudokuBoard* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GtkGrid** _tmp28_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	SudokuBoard* _tmp57_;
	gint _tmp58_;
	gint _tmp59_;
	SudokuCellView** _tmp60_;
	GtkOverlay* _tmp93_;
	GtkDrawingArea* _tmp94_;
	GtkOverlay* _tmp95_;
	GtkGrid* _tmp96_;
	GtkGrid* _tmp97_;
	GtkOverlay* _tmp98_;
	GtkDrawingArea* _tmp99_;
#line 614 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 614 "../src/sudoku-view.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 614 "../src/sudoku-view.vala"
	_data9_->_ref_count_ = 1;
#line 614 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 614 "../src/sudoku-view.vala"
	_g_object_unref0 (_data9_->game);
#line 614 "../src/sudoku-view.vala"
	_data9_->game = _tmp0_;
#line 614 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 614 "../src/sudoku-view.vala"
	_data9_->self = g_object_ref (self);
#line 616 "../src/sudoku-view.vala"
	gtk_frame_set_shadow_type ((GtkFrame*) self, GTK_SHADOW_NONE);
#line 617 "../src/sudoku-view.vala"
	g_object_set ((GtkAspectFrame*) self, "obey-child", FALSE, NULL);
#line 618 "../src/sudoku-view.vala"
	g_object_set ((GtkAspectFrame*) self, "ratio", (gfloat) 1, NULL);
#line 620 "../src/sudoku-view.vala"
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
#line 620 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp1_);
#line 620 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 620 "../src/sudoku-view.vala"
	self->priv->overlay = _tmp1_;
#line 621 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->overlay;
#line 621 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
#line 623 "../src/sudoku-view.vala"
	_tmp3_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 623 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 623 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->drawing);
#line 623 "../src/sudoku-view.vala"
	self->priv->drawing = _tmp3_;
#line 624 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->drawing;
#line 624 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp4_, "draw", (GCallback) _sudoku_view_draw_board_gtk_widget_draw, self, 0);
#line 626 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->grid;
#line 626 "../src/sudoku-view.vala"
	if (_tmp5_ != NULL) {
#line 3787 "sudoku-view.c"
		GtkOverlay* _tmp6_;
		GtkGrid* _tmp7_;
#line 627 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->overlay;
#line 627 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->grid;
#line 627 "../src/sudoku-view.vala"
		gtk_container_remove ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 3796 "sudoku-view.c"
	}
#line 629 "../src/sudoku-view.vala"
	_tmp8_ = _g_object_ref0 (_data9_->game);
#line 629 "../src/sudoku-view.vala"
	_g_object_unref0 (self->game);
#line 629 "../src/sudoku-view.vala"
	self->game = _tmp8_;
#line 630 "../src/sudoku-view.vala"
	_tmp9_ = self->game;
#line 630 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp9_, "paused-changed", (GCallback) ___lambda13__sudoku_game_paused_changed, self, 0);
#line 637 "../src/sudoku-view.vala"
	_tmp10_ = gtk_css_provider_new ();
#line 637 "../src/sudoku-view.vala"
	css_provider = _tmp10_;
#line 638 "../src/sudoku-view.vala"
	_tmp11_ = css_provider;
#line 638 "../src/sudoku-view.vala"
	gtk_css_provider_load_from_resource (_tmp11_, "/org/gnome/Sudoku/ui/gnome-sudoku.css");
#line 640 "../src/sudoku-view.vala"
	_tmp12_ = (GtkGrid*) gtk_grid_new ();
#line 640 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp12_);
#line 640 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 640 "../src/sudoku-view.vala"
	self->priv->grid = _tmp12_;
#line 641 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->grid;
#line 641 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp13_, 2);
#line 642 "../src/sudoku-view.vala"
	_tmp14_ = self->priv->grid;
#line 642 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp14_, 2);
#line 643 "../src/sudoku-view.vala"
	_tmp15_ = self->priv->grid;
#line 643 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp15_, TRUE);
#line 644 "../src/sudoku-view.vala"
	_tmp16_ = self->priv->grid;
#line 644 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp16_, TRUE);
#line 645 "../src/sudoku-view.vala"
	_tmp17_ = self->priv->grid;
#line 645 "../src/sudoku-view.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
#line 645 "../src/sudoku-view.vala"
	gtk_style_context_add_class (_tmp18_, "board");
#line 646 "../src/sudoku-view.vala"
	_tmp19_ = self->priv->grid;
#line 646 "../src/sudoku-view.vala"
	_tmp20_ = gtk_widget_get_style_context ((GtkWidget*) _tmp19_);
#line 646 "../src/sudoku-view.vala"
	_tmp21_ = css_provider;
#line 646 "../src/sudoku-view.vala"
	gtk_style_context_add_provider (_tmp20_, (GtkStyleProvider*) _tmp21_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 648 "../src/sudoku-view.vala"
	_tmp22_ = _data9_->game->board;
#line 648 "../src/sudoku-view.vala"
	_tmp23_ = sudoku_board_get_block_rows (_tmp22_);
#line 648 "../src/sudoku-view.vala"
	_tmp24_ = _tmp23_;
#line 648 "../src/sudoku-view.vala"
	_tmp25_ = _data9_->game->board;
#line 648 "../src/sudoku-view.vala"
	_tmp26_ = sudoku_board_get_block_cols (_tmp25_);
#line 648 "../src/sudoku-view.vala"
	_tmp27_ = _tmp26_;
#line 648 "../src/sudoku-view.vala"
	_tmp28_ = g_new0 (GtkGrid*, (_tmp24_ * _tmp27_) + 1);
#line 648 "../src/sudoku-view.vala"
	blocks = _tmp28_;
#line 648 "../src/sudoku-view.vala"
	blocks_length1 = _tmp24_;
#line 648 "../src/sudoku-view.vala"
	blocks_length2 = _tmp27_;
#line 3874 "sudoku-view.c"
	{
		gint block_row = 0;
#line 649 "../src/sudoku-view.vala"
		block_row = 0;
#line 3879 "sudoku-view.c"
		{
			gboolean _tmp29_ = FALSE;
#line 649 "../src/sudoku-view.vala"
			_tmp29_ = TRUE;
#line 649 "../src/sudoku-view.vala"
			while (TRUE) {
#line 3886 "sudoku-view.c"
				SudokuBoard* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
#line 649 "../src/sudoku-view.vala"
				if (!_tmp29_) {
#line 3892 "sudoku-view.c"
					gint _tmp30_;
#line 649 "../src/sudoku-view.vala"
					_tmp30_ = block_row;
#line 649 "../src/sudoku-view.vala"
					block_row = _tmp30_ + 1;
#line 3898 "sudoku-view.c"
				}
#line 649 "../src/sudoku-view.vala"
				_tmp29_ = FALSE;
#line 649 "../src/sudoku-view.vala"
				_tmp31_ = _data9_->game->board;
#line 649 "../src/sudoku-view.vala"
				_tmp32_ = sudoku_board_get_block_rows (_tmp31_);
#line 649 "../src/sudoku-view.vala"
				_tmp33_ = _tmp32_;
#line 649 "../src/sudoku-view.vala"
				if (!(block_row < _tmp33_)) {
#line 649 "../src/sudoku-view.vala"
					break;
#line 3912 "sudoku-view.c"
				}
				{
					gint block_col = 0;
#line 651 "../src/sudoku-view.vala"
					block_col = 0;
#line 3918 "sudoku-view.c"
					{
						gboolean _tmp34_ = FALSE;
#line 651 "../src/sudoku-view.vala"
						_tmp34_ = TRUE;
#line 651 "../src/sudoku-view.vala"
						while (TRUE) {
#line 3925 "sudoku-view.c"
							SudokuBoard* _tmp36_;
							gint _tmp37_;
							gint _tmp38_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid* _tmp42_;
							GtkGrid* _tmp43_;
							GtkGrid* _tmp44_;
							GtkStyleContext* _tmp45_;
							GtkGrid* _tmp46_;
							GtkStyleContext* _tmp47_;
							GtkCssProvider* _tmp48_;
							GtkGrid* _tmp49_;
							GtkGrid* _tmp50_;
							GtkGrid** _tmp51_;
							gint _tmp51__length1;
							gint _tmp51__length2;
							GtkGrid* _tmp52_;
							GtkGrid* _tmp53_;
#line 651 "../src/sudoku-view.vala"
							if (!_tmp34_) {
#line 3949 "sudoku-view.c"
								gint _tmp35_;
#line 651 "../src/sudoku-view.vala"
								_tmp35_ = block_col;
#line 651 "../src/sudoku-view.vala"
								block_col = _tmp35_ + 1;
#line 3955 "sudoku-view.c"
							}
#line 651 "../src/sudoku-view.vala"
							_tmp34_ = FALSE;
#line 651 "../src/sudoku-view.vala"
							_tmp36_ = _data9_->game->board;
#line 651 "../src/sudoku-view.vala"
							_tmp37_ = sudoku_board_get_block_cols (_tmp36_);
#line 651 "../src/sudoku-view.vala"
							_tmp38_ = _tmp37_;
#line 651 "../src/sudoku-view.vala"
							if (!(block_col < _tmp38_)) {
#line 651 "../src/sudoku-view.vala"
								break;
#line 3969 "sudoku-view.c"
							}
#line 653 "../src/sudoku-view.vala"
							_tmp39_ = (GtkGrid*) gtk_grid_new ();
#line 653 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp39_);
#line 653 "../src/sudoku-view.vala"
							block_grid = _tmp39_;
#line 654 "../src/sudoku-view.vala"
							_tmp40_ = block_grid;
#line 654 "../src/sudoku-view.vala"
							gtk_grid_set_row_spacing (_tmp40_, 1);
#line 655 "../src/sudoku-view.vala"
							_tmp41_ = block_grid;
#line 655 "../src/sudoku-view.vala"
							gtk_grid_set_column_spacing (_tmp41_, 1);
#line 656 "../src/sudoku-view.vala"
							_tmp42_ = block_grid;
#line 656 "../src/sudoku-view.vala"
							gtk_grid_set_column_homogeneous (_tmp42_, TRUE);
#line 657 "../src/sudoku-view.vala"
							_tmp43_ = block_grid;
#line 657 "../src/sudoku-view.vala"
							gtk_grid_set_row_homogeneous (_tmp43_, TRUE);
#line 658 "../src/sudoku-view.vala"
							_tmp44_ = block_grid;
#line 658 "../src/sudoku-view.vala"
							_tmp45_ = gtk_widget_get_style_context ((GtkWidget*) _tmp44_);
#line 658 "../src/sudoku-view.vala"
							gtk_style_context_add_class (_tmp45_, "block");
#line 659 "../src/sudoku-view.vala"
							_tmp46_ = block_grid;
#line 659 "../src/sudoku-view.vala"
							_tmp47_ = gtk_widget_get_style_context ((GtkWidget*) _tmp46_);
#line 659 "../src/sudoku-view.vala"
							_tmp48_ = css_provider;
#line 659 "../src/sudoku-view.vala"
							gtk_style_context_add_provider (_tmp47_, (GtkStyleProvider*) _tmp48_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 660 "../src/sudoku-view.vala"
							_tmp49_ = self->priv->grid;
#line 660 "../src/sudoku-view.vala"
							_tmp50_ = block_grid;
#line 660 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, block_col, block_row, 1, 1);
#line 662 "../src/sudoku-view.vala"
							_tmp51_ = blocks;
#line 662 "../src/sudoku-view.vala"
							_tmp51__length1 = blocks_length1;
#line 662 "../src/sudoku-view.vala"
							_tmp51__length2 = blocks_length2;
#line 662 "../src/sudoku-view.vala"
							_tmp52_ = block_grid;
#line 662 "../src/sudoku-view.vala"
							_tmp53_ = _g_object_ref0 (_tmp52_);
#line 662 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp51_[(block_row * _tmp51__length2) + block_col]);
#line 662 "../src/sudoku-view.vala"
							_tmp51_[(block_row * _tmp51__length2) + block_col] = _tmp53_;
#line 651 "../src/sudoku-view.vala"
							_g_object_unref0 (block_grid);
#line 4029 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 666 "../src/sudoku-view.vala"
	_tmp54_ = _data9_->game->board;
#line 666 "../src/sudoku-view.vala"
	_tmp55_ = sudoku_board_get_rows (_tmp54_);
#line 666 "../src/sudoku-view.vala"
	_tmp56_ = _tmp55_;
#line 666 "../src/sudoku-view.vala"
	_tmp57_ = _data9_->game->board;
#line 666 "../src/sudoku-view.vala"
	_tmp58_ = sudoku_board_get_cols (_tmp57_);
#line 666 "../src/sudoku-view.vala"
	_tmp59_ = _tmp58_;
#line 666 "../src/sudoku-view.vala"
	_tmp60_ = g_new0 (SudokuCellView*, (_tmp56_ * _tmp59_) + 1);
#line 666 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 666 "../src/sudoku-view.vala"
	self->priv->cells = _tmp60_;
#line 666 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp56_;
#line 666 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp59_;
#line 4058 "sudoku-view.c"
	{
		gint row = 0;
#line 667 "../src/sudoku-view.vala"
		row = 0;
#line 4063 "sudoku-view.c"
		{
			gboolean _tmp61_ = FALSE;
#line 667 "../src/sudoku-view.vala"
			_tmp61_ = TRUE;
#line 667 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4070 "sudoku-view.c"
				SudokuBoard* _tmp63_;
				gint _tmp64_;
				gint _tmp65_;
#line 667 "../src/sudoku-view.vala"
				if (!_tmp61_) {
#line 4076 "sudoku-view.c"
					gint _tmp62_;
#line 667 "../src/sudoku-view.vala"
					_tmp62_ = row;
#line 667 "../src/sudoku-view.vala"
					row = _tmp62_ + 1;
#line 4082 "sudoku-view.c"
				}
#line 667 "../src/sudoku-view.vala"
				_tmp61_ = FALSE;
#line 667 "../src/sudoku-view.vala"
				_tmp63_ = _data9_->game->board;
#line 667 "../src/sudoku-view.vala"
				_tmp64_ = sudoku_board_get_rows (_tmp63_);
#line 667 "../src/sudoku-view.vala"
				_tmp65_ = _tmp64_;
#line 667 "../src/sudoku-view.vala"
				if (!(row < _tmp65_)) {
#line 667 "../src/sudoku-view.vala"
					break;
#line 4096 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 669 "../src/sudoku-view.vala"
					col = 0;
#line 4102 "sudoku-view.c"
					{
						gboolean _tmp66_ = FALSE;
#line 669 "../src/sudoku-view.vala"
						_tmp66_ = TRUE;
#line 669 "../src/sudoku-view.vala"
						while (TRUE) {
#line 4109 "sudoku-view.c"
							Block10Data* _data10_;
							SudokuBoard* _tmp68_;
							gint _tmp69_;
							gint _tmp70_;
							SudokuCellView* cell = NULL;
							SudokuCellView* _tmp71_;
							SudokuCellView* _tmp72_;
							SudokuCellView* _tmp73_;
							SudokuCellView* _tmp74_;
							SudokuCellView** _tmp75_;
							gint _tmp75__length1;
							gint _tmp75__length2;
							SudokuCellView* _tmp76_;
							SudokuCellView* _tmp77_;
							GtkGrid** _tmp78_;
							gint _tmp78__length1;
							gint _tmp78__length2;
							SudokuBoard* _tmp79_;
							gint _tmp80_;
							gint _tmp81_;
							SudokuBoard* _tmp82_;
							gint _tmp83_;
							gint _tmp84_;
							GtkGrid* _tmp85_;
							SudokuCellView* _tmp86_;
							SudokuBoard* _tmp87_;
							gint _tmp88_;
							gint _tmp89_;
							SudokuBoard* _tmp90_;
							gint _tmp91_;
							gint _tmp92_;
#line 669 "../src/sudoku-view.vala"
							_data10_ = g_slice_new0 (Block10Data);
#line 669 "../src/sudoku-view.vala"
							_data10_->_ref_count_ = 1;
#line 669 "../src/sudoku-view.vala"
							_data10_->_data9_ = block9_data_ref (_data9_);
#line 669 "../src/sudoku-view.vala"
							if (!_tmp66_) {
#line 4149 "sudoku-view.c"
								gint _tmp67_;
#line 669 "../src/sudoku-view.vala"
								_tmp67_ = col;
#line 669 "../src/sudoku-view.vala"
								col = _tmp67_ + 1;
#line 4155 "sudoku-view.c"
							}
#line 669 "../src/sudoku-view.vala"
							_tmp66_ = FALSE;
#line 669 "../src/sudoku-view.vala"
							_tmp68_ = _data9_->game->board;
#line 669 "../src/sudoku-view.vala"
							_tmp69_ = sudoku_board_get_cols (_tmp68_);
#line 669 "../src/sudoku-view.vala"
							_tmp70_ = _tmp69_;
#line 669 "../src/sudoku-view.vala"
							if (!(col < _tmp70_)) {
#line 669 "../src/sudoku-view.vala"
								block10_data_unref (_data10_);
#line 669 "../src/sudoku-view.vala"
								_data10_ = NULL;
#line 669 "../src/sudoku-view.vala"
								break;
#line 4173 "sudoku-view.c"
							}
#line 671 "../src/sudoku-view.vala"
							_tmp71_ = sudoku_cell_view_new (row, col, &self->game);
#line 671 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp71_);
#line 671 "../src/sudoku-view.vala"
							cell = _tmp71_;
#line 672 "../src/sudoku-view.vala"
							_data10_->cell_row = row;
#line 673 "../src/sudoku-view.vala"
							_data10_->cell_col = col;
#line 675 "../src/sudoku-view.vala"
							_tmp72_ = cell;
#line 675 "../src/sudoku-view.vala"
							g_signal_connect_data ((GtkWidget*) _tmp72_, "focus-in-event", (GCallback) _________lambda14__gtk_widget_focus_in_event, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 686 "../src/sudoku-view.vala"
							_tmp73_ = cell;
#line 686 "../src/sudoku-view.vala"
							g_signal_connect_data ((GtkWidget*) _tmp73_, "focus-out-event", (GCallback) _________lambda15__gtk_widget_focus_out_event, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 697 "../src/sudoku-view.vala"
							_tmp74_ = cell;
#line 697 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp74_, "notify::value", (GCallback) _________lambda16__g_object_notify, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 706 "../src/sudoku-view.vala"
							_tmp75_ = self->priv->cells;
#line 706 "../src/sudoku-view.vala"
							_tmp75__length1 = self->priv->cells_length1;
#line 706 "../src/sudoku-view.vala"
							_tmp75__length2 = self->priv->cells_length2;
#line 706 "../src/sudoku-view.vala"
							_tmp76_ = cell;
#line 706 "../src/sudoku-view.vala"
							_tmp77_ = _g_object_ref0 (_tmp76_);
#line 706 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp75_[(row * _tmp75__length2) + col]);
#line 706 "../src/sudoku-view.vala"
							_tmp75_[(row * _tmp75__length2) + col] = _tmp77_;
#line 708 "../src/sudoku-view.vala"
							_tmp78_ = blocks;
#line 708 "../src/sudoku-view.vala"
							_tmp78__length1 = blocks_length1;
#line 708 "../src/sudoku-view.vala"
							_tmp78__length2 = blocks_length2;
#line 708 "../src/sudoku-view.vala"
							_tmp79_ = _data9_->game->board;
#line 708 "../src/sudoku-view.vala"
							_tmp80_ = sudoku_board_get_block_rows (_tmp79_);
#line 708 "../src/sudoku-view.vala"
							_tmp81_ = _tmp80_;
#line 708 "../src/sudoku-view.vala"
							_tmp82_ = _data9_->game->board;
#line 708 "../src/sudoku-view.vala"
							_tmp83_ = sudoku_board_get_block_cols (_tmp82_);
#line 708 "../src/sudoku-view.vala"
							_tmp84_ = _tmp83_;
#line 708 "../src/sudoku-view.vala"
							_tmp85_ = _tmp78_[((row / _tmp81_) * _tmp78__length2) + (col / _tmp84_)];
#line 708 "../src/sudoku-view.vala"
							_tmp86_ = cell;
#line 708 "../src/sudoku-view.vala"
							_tmp87_ = _data9_->game->board;
#line 708 "../src/sudoku-view.vala"
							_tmp88_ = sudoku_board_get_block_cols (_tmp87_);
#line 708 "../src/sudoku-view.vala"
							_tmp89_ = _tmp88_;
#line 708 "../src/sudoku-view.vala"
							_tmp90_ = _data9_->game->board;
#line 708 "../src/sudoku-view.vala"
							_tmp91_ = sudoku_board_get_block_rows (_tmp90_);
#line 708 "../src/sudoku-view.vala"
							_tmp92_ = _tmp91_;
#line 708 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp85_, (GtkWidget*) _tmp86_, col % _tmp89_, row % _tmp92_, 1, 1);
#line 669 "../src/sudoku-view.vala"
							_g_object_unref0 (cell);
#line 669 "../src/sudoku-view.vala"
							block10_data_unref (_data10_);
#line 669 "../src/sudoku-view.vala"
							_data10_ = NULL;
#line 4253 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 712 "../src/sudoku-view.vala"
	_tmp93_ = self->priv->overlay;
#line 712 "../src/sudoku-view.vala"
	_tmp94_ = self->priv->drawing;
#line 712 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp93_, (GtkWidget*) _tmp94_);
#line 713 "../src/sudoku-view.vala"
	_tmp95_ = self->priv->overlay;
#line 713 "../src/sudoku-view.vala"
	_tmp96_ = self->priv->grid;
#line 713 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) _tmp95_, (GtkWidget*) _tmp96_);
#line 714 "../src/sudoku-view.vala"
	_tmp97_ = self->priv->grid;
#line 714 "../src/sudoku-view.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp97_);
#line 715 "../src/sudoku-view.vala"
	_tmp98_ = self->priv->overlay;
#line 715 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp98_);
#line 716 "../src/sudoku-view.vala"
	_tmp99_ = self->priv->drawing;
#line 716 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp99_);
#line 614 "../src/sudoku-view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 614 "../src/sudoku-view.vala"
	_g_object_unref0 (css_provider);
#line 614 "../src/sudoku-view.vala"
	block9_data_unref (_data9_);
#line 614 "../src/sudoku-view.vala"
	_data9_ = NULL;
#line 614 "../src/sudoku-view.vala"
	return self;
#line 4294 "sudoku-view.c"
}

SudokuView*
sudoku_view_new (SudokuGame* game)
{
#line 614 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game);
#line 4302 "sudoku-view.c"
}

static void
sudoku_view_update_highlights (SudokuView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean has_selection = FALSE;
	gint cell_value = 0;
#line 719 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 721 "../src/sudoku-view.vala"
	if (self->priv->selected_row >= 0) {
#line 721 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->selected_col >= 0;
#line 4317 "sudoku-view.c"
	} else {
#line 721 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 4321 "sudoku-view.c"
	}
#line 721 "../src/sudoku-view.vala"
	has_selection = _tmp0_;
#line 722 "../src/sudoku-view.vala"
	cell_value = -1;
#line 723 "../src/sudoku-view.vala"
	if (has_selection) {
#line 4329 "sudoku-view.c"
		SudokuCellView** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCellView* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 724 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 724 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 724 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 724 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(self->priv->selected_row * _tmp1__length2) + self->priv->selected_col];
#line 724 "../src/sudoku-view.vala"
		_tmp3_ = sudoku_cell_view_get_value (_tmp2_);
#line 724 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_;
#line 724 "../src/sudoku-view.vala"
		cell_value = _tmp4_;
#line 4350 "sudoku-view.c"
	}
	{
		gint col_tmp = 0;
#line 726 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 4356 "sudoku-view.c"
		{
			gboolean _tmp5_ = FALSE;
#line 726 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 726 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4363 "sudoku-view.c"
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
#line 726 "../src/sudoku-view.vala"
				if (!_tmp5_) {
#line 4370 "sudoku-view.c"
					gint _tmp6_;
#line 726 "../src/sudoku-view.vala"
					_tmp6_ = col_tmp;
#line 726 "../src/sudoku-view.vala"
					col_tmp = _tmp6_ + 1;
#line 4376 "sudoku-view.c"
				}
#line 726 "../src/sudoku-view.vala"
				_tmp5_ = FALSE;
#line 726 "../src/sudoku-view.vala"
				_tmp7_ = self->game;
#line 726 "../src/sudoku-view.vala"
				_tmp8_ = _tmp7_->board;
#line 726 "../src/sudoku-view.vala"
				_tmp9_ = sudoku_board_get_cols (_tmp8_);
#line 726 "../src/sudoku-view.vala"
				_tmp10_ = _tmp9_;
#line 726 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp10_)) {
#line 726 "../src/sudoku-view.vala"
					break;
#line 4392 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 728 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 4398 "sudoku-view.c"
					{
						gboolean _tmp11_ = FALSE;
#line 728 "../src/sudoku-view.vala"
						_tmp11_ = TRUE;
#line 728 "../src/sudoku-view.vala"
						while (TRUE) {
#line 4405 "sudoku-view.c"
							SudokuGame* _tmp13_;
							SudokuBoard* _tmp14_;
							gint _tmp15_;
							gint _tmp16_;
							gboolean _tmp17_ = FALSE;
							gboolean _tmp18_ = FALSE;
							SudokuCellView** _tmp38_;
							gint _tmp38__length1;
							gint _tmp38__length2;
							SudokuCellView* _tmp39_;
							gboolean _tmp40_ = FALSE;
							gboolean _tmp41_ = FALSE;
							SudokuCellView** _tmp46_;
							gint _tmp46__length1;
							gint _tmp46__length2;
							SudokuCellView* _tmp47_;
#line 728 "../src/sudoku-view.vala"
							if (!_tmp11_) {
#line 4424 "sudoku-view.c"
								gint _tmp12_;
#line 728 "../src/sudoku-view.vala"
								_tmp12_ = row_tmp;
#line 728 "../src/sudoku-view.vala"
								row_tmp = _tmp12_ + 1;
#line 4430 "sudoku-view.c"
							}
#line 728 "../src/sudoku-view.vala"
							_tmp11_ = FALSE;
#line 728 "../src/sudoku-view.vala"
							_tmp13_ = self->game;
#line 728 "../src/sudoku-view.vala"
							_tmp14_ = _tmp13_->board;
#line 728 "../src/sudoku-view.vala"
							_tmp15_ = sudoku_board_get_rows (_tmp14_);
#line 728 "../src/sudoku-view.vala"
							_tmp16_ = _tmp15_;
#line 728 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp16_)) {
#line 728 "../src/sudoku-view.vala"
								break;
#line 4446 "sudoku-view.c"
							}
#line 730 "../src/sudoku-view.vala"
							if (has_selection) {
#line 730 "../src/sudoku-view.vala"
								_tmp18_ = self->priv->_highlighter;
#line 4452 "sudoku-view.c"
							} else {
#line 730 "../src/sudoku-view.vala"
								_tmp18_ = FALSE;
#line 4456 "sudoku-view.c"
							}
#line 730 "../src/sudoku-view.vala"
							if (_tmp18_) {
#line 4460 "sudoku-view.c"
								gboolean _tmp19_ = FALSE;
								gboolean _tmp20_ = FALSE;
#line 731 "../src/sudoku-view.vala"
								if (col_tmp == self->priv->selected_col) {
#line 731 "../src/sudoku-view.vala"
									_tmp20_ = TRUE;
#line 4467 "sudoku-view.c"
								} else {
#line 732 "../src/sudoku-view.vala"
									_tmp20_ = row_tmp == self->priv->selected_row;
#line 4471 "sudoku-view.c"
								}
#line 730 "../src/sudoku-view.vala"
								if (_tmp20_) {
#line 731 "../src/sudoku-view.vala"
									_tmp19_ = TRUE;
#line 4477 "sudoku-view.c"
								} else {
									gboolean _tmp21_ = FALSE;
									SudokuGame* _tmp22_;
									SudokuBoard* _tmp23_;
									gint _tmp24_;
									gint _tmp25_;
									SudokuGame* _tmp26_;
									SudokuBoard* _tmp27_;
									gint _tmp28_;
									gint _tmp29_;
#line 733 "../src/sudoku-view.vala"
									_tmp22_ = self->game;
#line 733 "../src/sudoku-view.vala"
									_tmp23_ = _tmp22_->board;
#line 733 "../src/sudoku-view.vala"
									_tmp24_ = sudoku_board_get_block_cols (_tmp23_);
#line 733 "../src/sudoku-view.vala"
									_tmp25_ = _tmp24_;
#line 733 "../src/sudoku-view.vala"
									_tmp26_ = self->game;
#line 733 "../src/sudoku-view.vala"
									_tmp27_ = _tmp26_->board;
#line 733 "../src/sudoku-view.vala"
									_tmp28_ = sudoku_board_get_block_cols (_tmp27_);
#line 733 "../src/sudoku-view.vala"
									_tmp29_ = _tmp28_;
#line 733 "../src/sudoku-view.vala"
									if ((col_tmp / _tmp25_) == (self->priv->selected_col / _tmp29_)) {
#line 4506 "sudoku-view.c"
										SudokuGame* _tmp30_;
										SudokuBoard* _tmp31_;
										gint _tmp32_;
										gint _tmp33_;
										SudokuGame* _tmp34_;
										SudokuBoard* _tmp35_;
										gint _tmp36_;
										gint _tmp37_;
#line 734 "../src/sudoku-view.vala"
										_tmp30_ = self->game;
#line 734 "../src/sudoku-view.vala"
										_tmp31_ = _tmp30_->board;
#line 734 "../src/sudoku-view.vala"
										_tmp32_ = sudoku_board_get_block_rows (_tmp31_);
#line 734 "../src/sudoku-view.vala"
										_tmp33_ = _tmp32_;
#line 734 "../src/sudoku-view.vala"
										_tmp34_ = self->game;
#line 734 "../src/sudoku-view.vala"
										_tmp35_ = _tmp34_->board;
#line 734 "../src/sudoku-view.vala"
										_tmp36_ = sudoku_board_get_block_rows (_tmp35_);
#line 734 "../src/sudoku-view.vala"
										_tmp37_ = _tmp36_;
#line 734 "../src/sudoku-view.vala"
										_tmp21_ = (row_tmp / _tmp33_) == (self->priv->selected_row / _tmp37_);
#line 4533 "sudoku-view.c"
									} else {
#line 733 "../src/sudoku-view.vala"
										_tmp21_ = FALSE;
#line 4537 "sudoku-view.c"
									}
#line 733 "../src/sudoku-view.vala"
									_tmp19_ = _tmp21_;
#line 4541 "sudoku-view.c"
								}
#line 730 "../src/sudoku-view.vala"
								_tmp17_ = _tmp19_;
#line 4545 "sudoku-view.c"
							} else {
#line 730 "../src/sudoku-view.vala"
								_tmp17_ = FALSE;
#line 4549 "sudoku-view.c"
							}
#line 730 "../src/sudoku-view.vala"
							_tmp38_ = self->priv->cells;
#line 730 "../src/sudoku-view.vala"
							_tmp38__length1 = self->priv->cells_length1;
#line 730 "../src/sudoku-view.vala"
							_tmp38__length2 = self->priv->cells_length2;
#line 730 "../src/sudoku-view.vala"
							_tmp39_ = _tmp38_[(row_tmp * _tmp38__length2) + col_tmp];
#line 730 "../src/sudoku-view.vala"
							sudoku_cell_view_set_highlighted_background (_tmp39_, _tmp17_);
#line 736 "../src/sudoku-view.vala"
							if (has_selection) {
#line 737 "../src/sudoku-view.vala"
								_tmp41_ = self->priv->_highlighter;
#line 4565 "sudoku-view.c"
							} else {
#line 736 "../src/sudoku-view.vala"
								_tmp41_ = FALSE;
#line 4569 "sudoku-view.c"
							}
#line 736 "../src/sudoku-view.vala"
							if (_tmp41_) {
#line 4573 "sudoku-view.c"
								SudokuCellView** _tmp42_;
								gint _tmp42__length1;
								gint _tmp42__length2;
								SudokuCellView* _tmp43_;
								gint _tmp44_;
								gint _tmp45_;
#line 738 "../src/sudoku-view.vala"
								_tmp42_ = self->priv->cells;
#line 738 "../src/sudoku-view.vala"
								_tmp42__length1 = self->priv->cells_length1;
#line 738 "../src/sudoku-view.vala"
								_tmp42__length2 = self->priv->cells_length2;
#line 738 "../src/sudoku-view.vala"
								_tmp43_ = _tmp42_[(row_tmp * _tmp42__length2) + col_tmp];
#line 738 "../src/sudoku-view.vala"
								_tmp44_ = sudoku_cell_view_get_value (_tmp43_);
#line 738 "../src/sudoku-view.vala"
								_tmp45_ = _tmp44_;
#line 738 "../src/sudoku-view.vala"
								_tmp40_ = cell_value == _tmp45_;
#line 4594 "sudoku-view.c"
							} else {
#line 736 "../src/sudoku-view.vala"
								_tmp40_ = FALSE;
#line 4598 "sudoku-view.c"
							}
#line 736 "../src/sudoku-view.vala"
							_tmp46_ = self->priv->cells;
#line 736 "../src/sudoku-view.vala"
							_tmp46__length1 = self->priv->cells_length1;
#line 736 "../src/sudoku-view.vala"
							_tmp46__length2 = self->priv->cells_length2;
#line 736 "../src/sudoku-view.vala"
							_tmp47_ = _tmp46_[(row_tmp * _tmp46__length2) + col_tmp];
#line 736 "../src/sudoku-view.vala"
							sudoku_cell_view_set_highlighted_value (_tmp47_, _tmp40_);
#line 4610 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static gboolean
sudoku_view_draw_board (SudokuView* self,
                        cairo_t* c)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 743 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 743 "../src/sudoku-view.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 745 "../src/sudoku-view.vala"
	_tmp0_ = self->game;
#line 745 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 745 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 745 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 4639 "sudoku-view.c"
		gint board_length = 0;
		GtkGrid* _tmp3_;
		gchar* text = NULL;
		gchar* _tmp4_;
		cairo_text_extents_t extents = {0};
		const gchar* _tmp5_;
		cairo_text_extents_t _tmp6_ = {0};
		cairo_text_extents_t _tmp7_;
		cairo_text_extents_t _tmp8_;
		const gchar* _tmp9_;
#line 747 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->grid;
#line 747 "../src/sudoku-view.vala"
		board_length = gtk_widget_get_allocated_width ((GtkWidget*) _tmp3_);
#line 749 "../src/sudoku-view.vala"
		cairo_set_source_rgba (c, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.75);
#line 750 "../src/sudoku-view.vala"
		cairo_paint (c);
#line 752 "../src/sudoku-view.vala"
		cairo_select_font_face (c, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 753 "../src/sudoku-view.vala"
		cairo_set_font_size (c, gtk_widget_get_allocated_width ((GtkWidget*) self) * 0.125);
#line 756 "../src/sudoku-view.vala"
		_tmp4_ = g_strdup (_ ("Paused"));
#line 756 "../src/sudoku-view.vala"
		text = _tmp4_;
#line 758 "../src/sudoku-view.vala"
		_tmp5_ = text;
#line 758 "../src/sudoku-view.vala"
		cairo_text_extents (c, _tmp5_, &_tmp6_);
#line 758 "../src/sudoku-view.vala"
		extents = _tmp6_;
#line 759 "../src/sudoku-view.vala"
		_tmp7_ = extents;
#line 759 "../src/sudoku-view.vala"
		_tmp8_ = extents;
#line 759 "../src/sudoku-view.vala"
		cairo_move_to (c, (board_length / 2.0) - (_tmp7_.width / 2.0), (board_length / 2.0) + (_tmp8_.height / 2.0));
#line 760 "../src/sudoku-view.vala"
		cairo_set_source_rgb (c, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 761 "../src/sudoku-view.vala"
		_tmp9_ = text;
#line 761 "../src/sudoku-view.vala"
		cairo_show_text (c, _tmp9_);
#line 745 "../src/sudoku-view.vala"
		_g_free0 (text);
#line 4686 "sudoku-view.c"
	}
#line 764 "../src/sudoku-view.vala"
	result = FALSE;
#line 764 "../src/sudoku-view.vala"
	return result;
#line 4692 "sudoku-view.c"
}

void
sudoku_view_clear (SudokuView* self)
{
#line 767 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 4700 "sudoku-view.c"
	{
		gint i = 0;
#line 769 "../src/sudoku-view.vala"
		i = 0;
#line 4705 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 769 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 769 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4712 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 769 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 4719 "sudoku-view.c"
					gint _tmp1_;
#line 769 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 769 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 4725 "sudoku-view.c"
				}
#line 769 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 769 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 769 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 769 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 769 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 769 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 769 "../src/sudoku-view.vala"
					break;
#line 4741 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 770 "../src/sudoku-view.vala"
					j = 0;
#line 4747 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 770 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 770 "../src/sudoku-view.vala"
						while (TRUE) {
#line 4754 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 770 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 4765 "sudoku-view.c"
								gint _tmp7_;
#line 770 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 770 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 4771 "sudoku-view.c"
							}
#line 770 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 770 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 770 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 770 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 770 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 770 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 770 "../src/sudoku-view.vala"
								break;
#line 4787 "sudoku-view.c"
							}
#line 771 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 771 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 771 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 771 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 771 "../src/sudoku-view.vala"
							sudoku_cell_view_clear (_tmp13_);
#line 4799 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_hide_popovers (SudokuView* self)
{
#line 819 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 4813 "sudoku-view.c"
	{
		gint i = 0;
#line 821 "../src/sudoku-view.vala"
		i = 0;
#line 4818 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 821 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 821 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4825 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 821 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 4832 "sudoku-view.c"
					gint _tmp1_;
#line 821 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 821 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 4838 "sudoku-view.c"
				}
#line 821 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 821 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 821 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 821 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 821 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 821 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 821 "../src/sudoku-view.vala"
					break;
#line 4854 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 822 "../src/sudoku-view.vala"
					j = 0;
#line 4860 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 822 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 822 "../src/sudoku-view.vala"
						while (TRUE) {
#line 4867 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 822 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 4878 "sudoku-view.c"
								gint _tmp7_;
#line 822 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 822 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 4884 "sudoku-view.c"
							}
#line 822 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 822 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 822 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 822 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 822 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 822 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 822 "../src/sudoku-view.vala"
								break;
#line 4900 "sudoku-view.c"
							}
#line 823 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 823 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 823 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 823 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 823 "../src/sudoku-view.vala"
							sudoku_cell_view_hide_both_popovers (_tmp13_);
#line 4912 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 777 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 777 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 777 "../src/sudoku-view.vala"
	return result;
#line 4931 "sudoku-view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
#line 778 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 779 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 4942 "sudoku-view.c"
	{
		gint i = 0;
#line 780 "../src/sudoku-view.vala"
		i = 0;
#line 4947 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 780 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 780 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4954 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 780 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 4961 "sudoku-view.c"
					gint _tmp1_;
#line 780 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 780 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 4967 "sudoku-view.c"
				}
#line 780 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 780 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 780 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 780 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 780 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 780 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 780 "../src/sudoku-view.vala"
					break;
#line 4983 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 781 "../src/sudoku-view.vala"
					j = 0;
#line 4989 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 781 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 781 "../src/sudoku-view.vala"
						while (TRUE) {
#line 4996 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 781 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 5007 "sudoku-view.c"
								gint _tmp7_;
#line 781 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 781 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 5013 "sudoku-view.c"
							}
#line 781 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 781 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 781 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 781 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 781 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 781 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 781 "../src/sudoku-view.vala"
								break;
#line 5029 "sudoku-view.c"
							}
#line 782 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 782 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 782 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 782 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 782 "../src/sudoku-view.vala"
							sudoku_cell_view_set_show_warnings (_tmp13_, self->priv->_show_warnings);
#line 5041 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 778 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 5050 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 789 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 789 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 789 "../src/sudoku-view.vala"
	return result;
#line 5063 "sudoku-view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
#line 790 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 791 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 5074 "sudoku-view.c"
	{
		gint i = 0;
#line 792 "../src/sudoku-view.vala"
		i = 0;
#line 5079 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 792 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 792 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5086 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 792 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5093 "sudoku-view.c"
					gint _tmp1_;
#line 792 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 792 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5099 "sudoku-view.c"
				}
#line 792 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 792 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 792 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 792 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 792 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 792 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 792 "../src/sudoku-view.vala"
					break;
#line 5115 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 793 "../src/sudoku-view.vala"
					j = 0;
#line 5121 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 793 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 793 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5128 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 793 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 5139 "sudoku-view.c"
								gint _tmp7_;
#line 793 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 793 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 5145 "sudoku-view.c"
							}
#line 793 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 793 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 793 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 793 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 793 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 793 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 793 "../src/sudoku-view.vala"
								break;
#line 5161 "sudoku-view.c"
							}
#line 794 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 794 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 794 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 794 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 794 "../src/sudoku-view.vala"
							sudoku_cell_view_set_show_possibilities (_tmp13_, value);
#line 5173 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 790 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 5182 "sudoku-view.c"
}

gboolean
sudoku_view_get_initialize_earmarks (SudokuView* self)
{
	gboolean result;
#line 801 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 801 "../src/sudoku-view.vala"
	result = self->priv->_initialize_earmarks;
#line 801 "../src/sudoku-view.vala"
	return result;
#line 5195 "sudoku-view.c"
}

void
sudoku_view_set_initialize_earmarks (SudokuView* self,
                                     gboolean value)
{
#line 802 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 803 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = value;
#line 5206 "sudoku-view.c"
	{
		gint i = 0;
#line 804 "../src/sudoku-view.vala"
		i = 0;
#line 5211 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 804 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 804 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5218 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 804 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5225 "sudoku-view.c"
					gint _tmp1_;
#line 804 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 804 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5231 "sudoku-view.c"
				}
#line 804 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 804 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 804 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 804 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 804 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 804 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 804 "../src/sudoku-view.vala"
					break;
#line 5247 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 805 "../src/sudoku-view.vala"
					j = 0;
#line 5253 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 805 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 805 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5260 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
#line 805 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 5271 "sudoku-view.c"
								gint _tmp7_;
#line 805 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 805 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 5277 "sudoku-view.c"
							}
#line 805 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 805 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 805 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 805 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 805 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 805 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 805 "../src/sudoku-view.vala"
								break;
#line 5293 "sudoku-view.c"
							}
#line 806 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 806 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 806 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 806 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 806 "../src/sudoku-view.vala"
							sudoku_cell_view_set_initialize_earmarks (_tmp13_, value);
#line 5305 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 802 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY]);
#line 5314 "sudoku-view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 813 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 813 "../src/sudoku-view.vala"
	result = self->priv->_highlighter;
#line 813 "../src/sudoku-view.vala"
	return result;
#line 5327 "sudoku-view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
#line 814 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 815 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 814 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 5340 "sudoku-view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
#line 586 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 586 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 586 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 586 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 586 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 586 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 586 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 586 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 586 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5365 "sudoku-view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 586 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 591 "../src/sudoku-view.vala"
	self->priv->previous_board_broken_state = FALSE;
#line 597 "../src/sudoku-view.vala"
	self->priv->selected_row = -1;
#line 598 "../src/sudoku-view.vala"
	self->priv->selected_col = -1;
#line 774 "../src/sudoku-view.vala"
	self->priv->_show_warnings = FALSE;
#line 786 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = FALSE;
#line 798 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = FALSE;
#line 810 "../src/sudoku-view.vala"
	self->priv->_highlighter = FALSE;
#line 5388 "sudoku-view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 586 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 588 "../src/sudoku-view.vala"
	_g_object_unref0 (self->game);
#line 589 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 593 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 594 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->drawing);
#line 595 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 586 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 5409 "sudoku-view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (gtk_aspect_frame_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 586 "../src/sudoku-view.vala"
	switch (property_id) {
#line 586 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 586 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 586 "../src/sudoku-view.vala"
		break;
#line 586 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 586 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 586 "../src/sudoku-view.vala"
		break;
#line 586 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 586 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_initialize_earmarks (self));
#line 586 "../src/sudoku-view.vala"
		break;
#line 586 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 586 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 586 "../src/sudoku-view.vala"
		break;
#line 5468 "sudoku-view.c"
		default:
#line 586 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 586 "../src/sudoku-view.vala"
		break;
#line 5474 "sudoku-view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 586 "../src/sudoku-view.vala"
	switch (property_id) {
#line 586 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 586 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 586 "../src/sudoku-view.vala"
		break;
#line 586 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 586 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 586 "../src/sudoku-view.vala"
		break;
#line 586 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 586 "../src/sudoku-view.vala"
		sudoku_view_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 586 "../src/sudoku-view.vala"
		break;
#line 586 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 586 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 586 "../src/sudoku-view.vala"
		break;
#line 5512 "sudoku-view.c"
		default:
#line 586 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 586 "../src/sudoku-view.vala"
		break;
#line 5518 "sudoku-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

